

<?php
define('IN_SITE', true);
include("common.php");

$template_body_page		= 'frame_menu.tpl';

show_menu();

function show_menu(){
	global $lang, $template, $db, $template_body_page;

	$template->set_filenames(array(
		'body'	=> $template_body_page,
	));

	$user_info		= get_user_info();
	$user_level 	= $user_info['user_level'];

	//Get function groups
	$sql = 'SELECT * FROM admin_function_groups ORDER BY group_order ASC';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$group_count	= $db->sql_numrows($result);
	$group_data		= $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	//Get functions
	$sql = 'SELECT * FROM admin_functions ORDER BY function_order ASC';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$function_count 	= $db->sql_numrows($result);
	$function_data  	= $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	//Remove functions which user does not have permission to access
	if ($user_info['user_level'] != SYSTEM_ADMIN)
	{
		remove_functions($function_count,$function_data);
	}
	//Remove groups in which there is not any function
	remove_empty_groups($group_count,$group_data,$function_count,$function_data);

	for ($i=0;$i<$group_count;$i++)
	{
		$template->assign_block_vars("group",array(
			'L_GROUP_NAME'		=> $lang[$group_data[$i]["group_name"]],
			'GROUP_COLOR'		=> $group_data[$i]["group_color"],
		));
		
		for ($j=0;$j<$function_count;$j++)
		{
			if ($group_data[$i]["group_id"] == $function_data[$j]["group_id"])
			{
				$template->assign_block_vars("group.func",array(
					'L_FUNC_NAME'		=> $lang[$function_data[$j]["function_name"]],
					'U_FUNC_URL'		=> $function_data[$j]["function_url"],
					'FUNC_TARGET'		=> !empty($function_data[$j]["function_target"]) ? 'target="'. $function_data[$j]["function_target"] .'"' : '',
				));
			}
		}
	}
	
	$template->pparse('body');
}

function remove_empty_groups( &$group_count, &$group_data, $function_count, $function_data)
{
	$tmpgroup_count		= 0;
	$tmpgroup_data		= array();

	for ($i=0;$i<$group_count;$i++)
	{
		$flag = 0;
		for ($j=0;$j<$function_count;$j++)
		{
			if ($group_data[$i]['group_id'] == $function_data[$j]['group_id'])
			{
				$flag = 1;
				break;
			}
		}
		
		if ($flag)
		{
			$tmpgroup_count++;
			$tmpgroup_data[] = $group_data[$i];
		}
	}

	$group_count 	= $tmpgroup_count;
	$group_data  	= $tmpgroup_data;
}

function remove_functions( &$function_count, &$function_data){
	global $db;

	$user_info = get_user_info();

	//Get all auth levels
	$sql = "SELECT * FROM admin_auth_access WHERE user_id=". $user_info['user_id'];
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$level_count	= $db->sql_numrows($result);
	$level_data		= array();
	while ($level_info = $db->sql_fetchrow($result))
	{
		$level_data[$level_info['function_id']]['auth_level'] = $level_info['auth_level'];
	}
	$db->sql_freeresult($result);	

	$tmpfunction_count	= 0;
	$tmpfunction_data	= array();

	for ($i=0;$i<$function_count;$i++)
	{
		$function_id	= $function_data[$i]['function_id'];
		$auth_level		= isset($level_data[$function_id]['auth_level']) ? $level_data[$function_id]['auth_level'] : 0;
		if ( $function_data[$i]['function_alluser']||check_menu_auth($auth_level,$function_id) )
		{
			$tmpfunction_count++;
			$tmpfunction_data[] = $function_data[$i];
		}
	}

	$function_count		= $tmpfunction_count;
	$function_data  	= $tmpfunction_data;
}

function check_menu_auth( $auth_level, $function_id){
	global $db, $access_user;

	if ( !isset($access_user[$auth_level]) || !is_array($access_user[$auth_level]) ) return false;

	reset($access_user[$auth_level]);
	while (list(,$access) = each($access_user[$auth_level])){
		if ($access == "yes"){
			return true;
		}
	}

	return false;
}
?>