

<?php
define('IN_SITE', true);
include("common.php");

$template_body_page		= 'frame_preview.tpl';

list_info();

function list_info(){
	global $lang, $template, $template_body_page;

	get_func_info(array('pro_cat.php'	=> 'pro_cat', 'pro.php'	=> 'pro'));
	get_func_info(array('user.php'	=> 'admin_users'));

	//Get user online
	get_user_online();

	$template->set_filenames(array(
		'body'	=> $template_body_page,
	));

	//Get username
	$user_info = get_user_info();

	$template->assign_vars(array(
		'HELLO_MESSAGE'			=> sprintf($lang['general_hello'], $user_info['username']),
		'L_GENERAL_PREVIEW'		=> $lang['menu_general_preview'],
		'L_GENERAL_ONLINE'		=> $lang['general_online'],
		'L_IP'					=> $lang['general_ip'],
	));

	$template->pparse('body');
}

function get_user_online(){
	global $db, $site_option, $template;

	$login_time = time() - $site_option['login_expiretime'];

	$sql = "SELECT * FROM admin_users WHERE user_login_id!='' AND user_login_time>=$login_time";
	if ( !$result = $db->sql_query($sql) )
	{
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$user_count = $db->sql_numrows($result);
	$user_data	= $db->sql_fetchrowset($result);

	for ($i=0; $i<$user_count; $i++){
		$template->assign_block_vars("userrow",array(
			'USER_ID'		=> $user_data[$i]['user_id'],
			'USERNAME'		=> $user_data[$i]['username'],
			'USER_IP'		=> $user_data[$i]['user_ip'],
		));
	}
}

//Function array : function url => sql table name
function get_func_info($func_array){
	global $lang, $db, $template;

	if ( !is_array($func_array) ) return false;

	$counter = array();

	$where_sql = " (F.function_url=''";
	reset($func_array);
	while (list($url,$tbl) = each($func_array) ){
		$where_sql .= " OR F.function_url='". $url ."'";
		
		//Count records
		$sql = "SELECT count(*) AS total FROM $tbl";
		if (!$result = $db->sql_query($sql)) {
			message_die("Error getting total count.", __LINE__, __FILE__, $sql);
		}
		if ($db->sql_numrows($result)){
			$tmp_info = $db->sql_fetchrow($result);
			$counter[$url] = $tmp_info['total'];
		}
	}
	$where_sql .= ")";


	$sql = "SELECT F.*, G.* FROM admin_functions AS F, admin_function_groups AS G WHERE F.group_id=G.group_id AND $where_sql";
	if (!$result = $db->sql_query($sql)) {
		message_die("Error getting total count.", __LINE__, __FILE__, $sql);
	}
	$func_count	= $db->sql_numrows($result);
	$func_data	= $db->sql_fetchrowset($result);

	if ($func_count){
		$template->assign_block_vars("grouprow", array(
			'L_GROUP_NAME'		=> $lang[$func_data[0]['group_name']],
		));
		
		for ($i=0;$i<$func_count;$i++){
			$template->assign_block_vars("grouprow.funcrow",array(
				'L_FUNC_NAME'		=> $lang[$func_data[$i]['function_name']],
				'U_FUNC_URL'		=> $func_data[$i]['function_url'],
				'COUNTER'			=> isset($counter[$func_data[$i]['function_url']]) ? $counter[$func_data[$i]['function_url']] : 0,
			));
		}
	}

}
?>

