

<?php
define('IN_SITE', true);
include("common.php");

$base_url 			= 'option.php';
$template_body_page	= 'option_body.tpl';
$language_root		= './languages/';

$mode = isset($_GET['mode']) ? htmlspecialchars($_GET['mode']) : '';
if ($mode == "update"){
	update_info();
}
else{
	show_info();
}

function show_info($msg=""){
	global $lang, $db, $template, $template_body_page, $base_url, $system_lang;

	$option = get_all_options();

	$template->set_filenames(array(
		'body' => $template_body_page
	) );

	reset($system_lang);
	while ( list($dir,$name) = each($system_lang) ){
		$template->assign_block_vars('langrow',array(
			'DIR'	=> $dir,
			'NAME'	=> $name
		));
	}

	$template->assign_vars(array(
		"S_OPTION_ACTION"			=> $base_url . '?mode=update',
		'L_ERR_MESSAGE'				=> $msg,
		'SITENAME_VALUE'			=> $option['sitename'],
		'ADMINEMAIL_VALUE'			=> $option['admin_email'],
		'PRODUCTCURRENCY_VALUE'		=> $option['product_currency'],
		'COOKIEID_VALUE'			=> $option['cookie_login_id'],
		'ITEMPERPAGE_VALUE'			=> $option['items_per_page'],
		'DATEFORMAT_VALUE'			=> $option['date_format'],
		'EXPIRETIME_VALUE'			=> $option['login_expiretime'],
		'LANGUAGE_VALUE'			=> $option['language'],
		'L_PAGE_NAVIGATION'			=> $lang['menu_admin'] . $lang['general_arrow'] . $lang['menu_admin_config'],
		'L_SITE_NAME'				=> $lang['config_site_name'],
		'L_ADMIN_EMAIL'				=> $lang['config_admin_email'],
		'L_PRODUCT_CURRENCY'		=> $lang['config_product_currency'],
		'L_ITEMS_PER_PAGE'			=> $lang['config_items_per_page'],
		'L_DATE_FORMAT'				=> $lang['config_date_format'],
		'L_LOGIN_TIME'				=> $lang['config_login_time'],
		'L_LANGUAGE'				=> $lang['config_language'],
		'L_SUBMIT'					=> $lang['general_update'],
	) );
	
	$template->pparse('body');
}

function update_info(){
	global $lang, $db, $template, $language_root, $base_url;

	$data = array();
	$data['sitename'] 			= isset($_POST['sitename']) ? htmlspecialchars($_POST['sitename']) : '';
	$data['admin_email']		= isset($_POST['admin_email']) ? htmlspecialchars($_POST['admin_email']) : '';
	$data['product_currency'] 	= isset($_POST['product_currency']) ? htmlspecialchars($_POST['product_currency']) : '';
	$data['items_per_page'] 	= isset($_POST['items_per_page']) ? htmlspecialchars($_POST['items_per_page']) : '';
	$data['cookie_login_id'] 	= isset($_POST['cookie_login_id']) ? htmlspecialchars($_POST['cookie_login_id']) : '';
	$data['date_format']		= isset($_POST['date_format']) ? htmlspecialchars($_POST['date_format']) : '';
	$data['login_expiretime']	= isset($_POST['login_expiretime']) ? htmlspecialchars($_POST['login_expiretime']) : '';
	$data['language']			= isset($_POST['language']) ? str_replace('\\','',htmlspecialchars($_POST['language'])) : '';

	//Check exist language dir
	if ( !file_exists($language_root . $data['language']) ){
		$data['language']		= '';
	}
	clearstatcache();

	$user_info = get_user_info();

	if ( !empty($data['language']) && empty($user_info['user_language']) ){
		//Get old language
		$sql = 'SELECT option_value FROM site_option WHERE option_name="language"';
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
		if ($db->sql_numrows($result)){
			$option_info = $db->sql_fetchrow($result);
			if ($data['language'] != $option_info['option_value']){
				$template->assign_vars(array(
					'CAL_LANG_FUNCTION'		=> 'change_language();',
				));
				$lang = array();//Unset lang
				require($language_root . $data['language'] . '/lang.php');//New lang
			}
		}
	}

	//Update site options
	reset($data);
	while (list($key,$val) = each($data)){
		if ( !empty($key) && !empty($val) ){
			$sql = "UPDATE site_option SET option_value='". $val ."' WHERE option_name='". $key ."'";
			if ( !$result = $db->sql_query($sql) ) {
				message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
			}
		}
	}

	show_info($lang['success_update']);
}
?>
