

<?php
define('IN_SITE', true);
define("CAT_LEVEL", 1);
include("common.php");

$base_url					= 'pro.php';
$upload_path				= '../images/product/'; //Chu y co dau / phia sau
$image_path					= 'images/product/';
$template_edit_page 		= "pro_edit.tpl";
$template_body_page 		= "pro_body.tpl";
$template_view_page 		= "pro_view.tpl";
$template_move_page 		= "pro_move.tpl";
$template_picture_page 		= "pro_picture.tpl";

$auth_level = check_any_auth($base_url);
if ($auth_level == ACCESS_CHECKER){
	$checker = 1;
}
else{
	$checker = 0;
}

//---------------------- Image Size ------------------------
$max_thumbwidth		= 250;//100: Limit width is 100
$max_thumbheight	= 150;//0: Not limit
$max_fullwidth		= 500;//200: Limit width is 200
$max_fullheight		= 420;//0: Not limit
get_imgsize();
//----------------------------------------------------------

//------------ Get filter --------------
$filter		= array();
get_filter();
//--------------------------------------

$data				= array();
$cat_data			= array();
$sort_catdata		= array();
$start				= isset($_GET["start"]) ? intval($_GET["start"]) : 0;
$mode				= isset($_GET["mode"]) ? htmlspecialchars($_GET["mode"]) : '';

switch ($mode){
	case "add":
		check_specify_auth($auth_level,'add');
		pre_add_product();
		break;
	case "addsm":
		check_specify_auth($auth_level,'add');
		do_add_product();
		break;
	case "edit":
		check_specify_auth($auth_level,'edit');
		if ($checker){
			die("You don't have permission to access this function");
		}
		pre_edit_product();
		break;
	case "editsm":
		check_specify_auth($auth_level,'edit');
		if ($checker){
			die("You don't have permission to access this function");
		}
		do_edit_product();
		break;
	case "move":
		check_specify_auth($auth_level,'edit');
		if ($checker){
			die("You don't have permission to access this function");
		}
		pre_move_products();
		break;
	case "movesm":
		check_specify_auth($auth_level,'edit');
		if ($checker){
			die("You don't have permission to access this function");
		}
		do_move_products();
		break;
	case "del":
		check_specify_auth($auth_level,'delete');
		delete_products();
		break;
	case "active":
		check_specify_auth($auth_level,'active');
		active_products();
		break;
	case "update":
		check_specify_auth($auth_level,'edit');
		update_orders();
		break;
	case "resync":
		resync_orders();
		break;
	case "view":
		view_product();
		break;
	case "thumb":
		view_picture("pic_thumb");
		break;
	case "full":
		view_picture("pic_full");
		break;
	default:
		list_products();
}

function get_filter(){
	global $filter, $template;

	$filter['enabled']		= isset($_POST["fenabled"]) ? intval($_POST["fenabled"]) : -1;
	$filter['cat_id'] 		= isset($_POST["fcat_id"]) ? intval($_POST["fcat_id"]) : 0;
	$filter['keyword'] 		= isset($_POST["fkeyword"]) ? htmlspecialchars($_POST["fkeyword"]) : '';
	if ( $filter['enabled'] == -1 ){
		$filter['enabled']	= isset($_GET["fenabled"]) ? intval($_GET["fenabled"]) : -1;
	}
	if ( !$filter['cat_id'] ){
		$filter['cat_id'] 	= isset($_GET["fcat_id"]) ? intval($_GET["fcat_id"]) : 0;
	}
	if ( empty($filter['keyword']) ){
		$filter['keyword'] 	= isset($_GET["fkeyword"]) ? htmlspecialchars($_GET["fkeyword"]) : '';
	}

	$filter['url_append']	= "";
	if ( $filter['enabled'] != -1 ){
		$filter['url_append']	.= "&fenabled=". $filter['enabled'];
	}
	if ( $filter['cat_id'] ){
		$filter['url_append']	.= "&fcat_id=". $filter['cat_id'];
	}
	if ( !empty($filter['keyword']) ){
		$filter['url_append']	.= "&fkeyword=". $filter['keyword'];
	}

	$template->assign_vars(array(
		'FENABLED_VALUE'	=> $filter['enabled'],
		'FCATID_VALUE'		=> $filter['cat_id'],
		'FKEYWORD_VALUE'	=> $filter['keyword'],
	));
}

function get_imgsize(){
	global $lang, $template, $max_fullwidth, $max_fullheight, $max_thumbwidth, $max_thumbheight;

	if ($max_thumbwidth && $max_thumbheight){
		$thumbsize 		= sprintf($lang['general_pic_size'], $max_thumbwidth .' x '. $max_thumbheight);
	}
	else if ($max_thumbwidth){
		$thumbsize 		= sprintf($lang['general_pic_width'], $max_thumbwidth);
	}
	else if ($max_thumbheight){
		$thumbsize 		= sprintf($lang['general_pic_height'], $max_thumbheight);
	}
	else{
		$thumbsize 		= "";
	}

	if ($max_fullwidth && $max_fullheight){
		$fullsize 		= sprintf($lang['general_pic_size'], $max_fullwidth .' x '. $max_fullheight);
	}
	else if ($max_fullwidth){
		$fullsize 		= sprintf($lang['general_pic_width'], $max_fullwidth);
	}
	else if ($max_fullheight){
		$fullsize 		= sprintf($lang['general_pic_height'], $max_fullheight);
	}
	else{
		$fullsize 		= "";
	}

	$template->assign_vars(array(
		'THUMBSIZE'		=> $thumbsize,
		'FULLSIZE'		=> $fullsize,
	));
}

function list_products(){
	global $lang, $template, $db, $base_url, $site_option, $template_body_page, $auth_level, $filter, $start, $checker, $user_info;

	$itemperpage 	= $site_option['items_per_page'];
	$currency		= $site_option['product_currency'];

	get_all_cats();
	if (CAT_LEVEL > 1){
		get_sub_cats(0,0,0,"");
	}
	else{
		get_sub_cats(0,0,0,"","");
	}
	show_cats();

	//Filter ------------------------
	$where_sql = ' WHERE product_id>0';
	if ( $filter['enabled'] != -1 ){
		$where_sql	.= ' AND enabled='. $filter['enabled'];
	}
	if ( $filter['cat_id'] ){
		$where_sql .= ' AND (cat_id='. $filter['cat_id'];
//		get_subcat_id($fcat_id, $where_sql);
		$where_sql .= ')';
	}
	if ( !empty($filter['keyword']) ){
		$keyword 	= str_replace('*','%', $keyword);
		$where_sql .= " AND (title LIKE('%". $keyword ."%') OR code LIKE('%". $keyword ."%') OR detail LIKE('%". $keyword ."%'))";
	}
	//-------------------------------

	//Get products
	$sql = 'SELECT * FROM pro '. $where_sql .' ORDER BY code ASC LIMIT '. $start .','. $itemperpage;
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$product_count	= $db->sql_numrows($result);
	$product_data	= $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	//Generate Pagination
	$sql = 'SELECT count(*) AS total FROM pro ' . $where_sql;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Error getting total count.", __LINE__, __FILE__, $sql);
	}
	else {
		$total 			= $db->sql_fetchrow($result);
		$pagination 	= pagination($base_url . "?". $filter['url_append'], $total['total'], $itemperpage, $start, 'start', $lang['general_page'] . ': //<img src="images/prev.gif" border="0">//<img src="images/next.gif" border="0">')."&nbsp;";
	}

	if ($user_info['user_level'] == SYSTEM_ADMIN){
		$auth_add 		= 1;
		$auth_edit 		= 1;
		$auth_delete 	= 1;
		$auth_active 	= 1;
	}
	else{
		$auth_add 		= check_specify_auth($auth_level,'add',0) ? 1 : 0;
		$auth_edit 		= check_specify_auth($auth_level,'edit',0) ? 1 : 0;
		$auth_delete 	= check_specify_auth($auth_level,'delete',0) ? 1 : 0;
		$auth_active 	= check_specify_auth($auth_level,'active',0) ? 1 : 0;
	}

	for ($i=0;$i<$product_count;$i++){
		$template->assign_block_vars("productrow",array(
			'ID'				=> $product_data[$i]['product_id'],
			'PIC'				=> (!empty($product_data[$i]['pic_thumb']) || !empty($product_data[$i]['pic_full'])) ? '<img src="./images/pic.gif">' : '',
			'ORDER'				=> $product_data[$i]['product_order'],
			'TITLE'				=> $product_data[$i]['title'],
			'CODE'				=> $product_data[$i]['code'],
			'DETAIL'				=> $product_data[$i]['detail'],
			'PRICE'				=> $product_data[$i]['price'] ? number_format($product_data[$i]['price'],DECIMALS,DEC_POINT,THOUSANDS_SEP) : '',
			'CSS'				=> ($product_data[$i]['enabled']) ? 'enabled' : 'disabled',
			'U_VIEW'			=> $base_url . '?mode=view&id='. $product_data[$i]['product_id'],
			'U_EDIT'			=> ( $auth_edit && !$checker ) ? '<a href="'. $base_url .'?mode=edit&id='. $product_data[$i]['product_id'] . $filter['url_append'] .'&start='.$start.'"><img src=images/edit.gif width=16 height=16 border=0 alt="'. $lang['general_edit'] .'"></a>' : '&nbsp;',
		));
	}

	$template->assign_vars(array(
		'CURRENCY'				=> $currency,
		'S_FILTER_ACTION'		=> $base_url,
		'U_NEW'					=> $auth_add ? '<a href="'. $base_url . '?mode=add"><img src="images/new.gif" width="20" height="14" alt="'. $lang['general_new'] .'" border="0" align="absbottom">'. $lang['general_new'] .'</a>' : '&nbsp;',
		'NAVIGATOR'				=> $pagination,
		'S_LIST_ACTION'			=> $base_url . '?mode=active'. $filter['url_append'] .'&start='. $start,
		'U_ACTIVE'				=> $auth_active ? '<a href="javascript:submit_list(\'enable\');"><img src="images/enabled.gif" width="20" height="14" alt="'. $lang['general_enable'] .'" border="0" align="absbottom">'. $lang['general_enable'] .'</a> &nbsp;-&nbsp; <a href="javascript:submit_list(\'disable\');"><img src="images/disabled.gif" width="20" height="14" alt="'. $lang['general_disable'] .'" border="0" align="absbottom">'. $lang['general_disable'] .'</a>' : '&nbsp;',
		'U_DELETE'				=> $auth_delete ? '<a href="javascript: delete_list(\''. $base_url.'?mode=del'. $filter['url_append'] .'&start='. $start . '\');"><img src=images/del.gif width=16 height=16 border=0 alt="'. $lang['general_del'] .'"> '. $lang['general_del'] .'</a>' : '&nbsp;',
		'U_MOVE'				=> $auth_edit ? '<a href="javascript: updateForm(\''. $base_url.'?mode=move'. $filter['url_append'] .'&start='.$start . '\');"><img src=images/move.gif width=20 height=14 border=0 alt="'. $lang['general_move'] .'">'. $lang['general_move'] .'</a>' : '&nbsp;',
		'U_UPDATE'				=> $auth_edit ? '<a href="javascript: updateForm2(\''. $base_url.'?mode=update'. $filter['url_append'] .'&start='.$start . '\');"><img src=images/update.gif border=0 alt="'. $lang['general_update'] .'">'. $lang['general_update'] .'</a>' : '&nbsp;',
		'U_RESYNC'				=> $auth_edit ? '<a href="'. $base_url.'?mode=resync'. $filter['url_append'] .'&start='.$start . '"><img src=images/resynce.gif border=0 alt="'. $lang['general_resync'] .'">'. $lang['general_resync'] .'</a>' : '&nbsp;',
		'L_PAGE_NAVIGATION'		=> $lang['menu_pro'] . $lang['general_arrow'] . $lang['menu_pro_product'],
		'L_ALL'					=> $lang['general_all'],
		'L_STATUS'				=> $lang['general_status'],
		'L_CAT'					=> $lang['product_cat'],
		'L_NUM_ORDER'			=> $lang['general_num_order'],
		'L_TITLE'				=> $lang['product_title'],
		'L_CODE'				=> $lang['product_code'],
		'L_PRICE'				=> $lang['product_price'],
		'L_DETAIL'				=> $lang['product_detail'],
		'L_EDIT'				=> $lang['general_edit'],
		'L_DEL'					=> $lang['general_del'],
		'L_ENABLED'				=> $lang['general_enabled'],
		'L_DISABLED'			=> $lang['general_disabled'],
		'L_CHOOSE_PRODUCT'		=> $lang['error_product_not_choose'],
		'L_GO_SUBMIT'			=> $lang['button_go'],
	));	

	$template->set_filenames(array(
		"body"	=> $template_body_page
	));
	$template->pparse('body');
}

function pre_add_product($msg = ""){
	global $lang, $template, $base_url, $template_edit_page, $upload_path, $upload_type, $data, $site_option;

	$currency		= $site_option['product_currency'];

	set_lang_update();
	$template->assign_vars(array(
		'L_ERR_MESSAGE'			=> $msg,
		'S_ACTION'				=> $base_url . '?mode=addsm',
		'CURRENCY'				=> $currency,
		'CATID_VALUE'			=> isset($data['cat_id']) ? $data['cat_id'] : 0,
		'CODE_VALUE'			=> isset($data['code']) ? stripslashes($data['code']) : '',
		'DIMENSION_VALUE'		=> isset($data['dimension']) ? stripslashes($data['dimension']) : '',
		'COLOR_VALUE'			=> isset($data['color']) ? stripslashes($data['color']) : '',
		'PRICE_VALUE'			=> isset($data['price']) ? stripslashes($data['price']) : '',
		'TITLE_VALUE'			=> isset($data['title']) ? stripslashes($data['title']) : '',
		'DETAIL_VALUE'			=> isset($data['detail']) ? stripslashes($data['detail']) : '',
		'ACTIVE_VALUE'			=> isset($data['active']) ? $data['active'] : '',
		'L_PAGE_NAVIGATION'		=> $lang['menu_pro'] . $lang['general_arrow'] . $lang['menu_pro_product'] . $lang['general_arrow'] . $lang['general_new'],
		'L_SUBMIT'				=> $lang['button_new'],
	));
	$template->assign_block_vars("addrow",array());

	get_all_cats();
	if (CAT_LEVEL > 1){
		get_sub_cats(0,0,0,"");
	}
	else{
		get_sub_cats(0,0,0,"","");
	}
	show_cats();

	$template->set_filenames(array(
		"body"	=> $template_edit_page
	));
	$template->pparse('body');
}

function set_lang_update(){
	global $template, $lang;

	$template->assign_vars(array(
		'L_CAT'					=> $lang['product_cat'],
		'L_PIC_THUMB'			=> $lang['general_pic_thumb'],
		'L_PIC_FULL'			=> $lang['general_pic_full'],
		'L_CODE'				=> $lang['product_code'],
		'L_DIMENSION'			=> $lang['product_dimension'],
		'L_COLOR'				=> $lang['product_color'],
		'L_PRICE'				=> $lang['product_price'],
		'L_TITLE'				=> $lang['product_title'],
		'L_DETAIL'				=> $lang['general_detail'],
		'L_CHOOSE'				=> $lang['general_choose'],
		'L_ACTIVE'				=> $lang['general_active'],
		'L_ENABLED'				=> $lang['general_enabled'],
		'L_DISABLED'			=> $lang['general_disabled'],
		'L_PAGETO'				=> $lang['general_pageto'],
		'L_SAVE'				=> $lang['general_save'],
		'L_INSERT_AS_NEWROW'	=> $lang['general_insert_as_newrow'],
		'L_GOTO_LISTPAGE'		=> $lang['general_goto_listpage'],
		'L_CONTINUE_ADD'		=> $lang['general_continue_add'],
	));
}

function do_add_product(){
	global $lang, $lang, $db, $template, $base_url, $auth_level, $upload_path, $data, $max_thumbwidth, $max_thumbheight, $max_fullwidth, $max_fullheight;

	$data['cat_id']			= isset($_POST["cat_id"]) ? intval($_POST["cat_id"]) : 0;
	$data['pic_thumb']		= isset($_FILES['pic_thumb']['name']) ? htmlspecialchars($_FILES['pic_thumb']['name']) : '';
	$data['pic_full']		= isset($_FILES['pic_full']['name']) ? htmlspecialchars($_FILES['pic_full']['name']) : '';
	$data['code']			= isset($_POST["code"]) ? htmlspecialchars($_POST["code"]) : '';
	$data['dimension']		= isset($_POST["dimension"]) ? htmlspecialchars($_POST["dimension"]) : '';
	$data['color']			= isset($_POST["color"]) ? htmlspecialchars($_POST["color"]) : '';
	$data['price']			= isset($_POST["price"]) ? floatval($_POST["price"]) : 0;
	$data['title']			= isset($_POST["title"]) ? htmlspecialchars($_POST["title"]) : '';
	$data['detail']			= isset($_POST["detail"]) ? htmlspecialchars($_POST["detail"]) : '';
	$data['active']			= isset($_POST["active"]) ? intval($_POST["active"]) : 0;
	if (!check_specify_auth($auth_level,'active',0)){
		$data['active'] = 0;
	}
	$data['pageto'] 	= isset($_POST["pageto"]) ? htmlspecialchars($_POST["pageto"]) : '';

//	if ( !$data['cat_id'] || empty($data['pic_thumb']) || empty($data['title']) ){
//		pre_add_product($lang['error_no_allfields']);
	if ( !$data['cat_id'] || empty($data['code']) || empty($data['detail']) ){
		pre_add_product($lang['error_no_allfields']);

		return false;
	}

	//Check and move upload thumb file -----------
	if ( !empty($data['pic_thumb']) && is_uploaded_file($_FILES['pic_thumb']['tmp_name']) ){
		if (!check_file_type($data['pic_thumb'])){
			pre_add_product($lang['error_file_type']);
			return false;
		}
		else{
			while ( file_exists($upload_path . $data['pic_thumb']) ) {
				$data['pic_thumb'] = str_replace('.', rand(1, 9) . '.', $data['pic_thumb']);
			}
			move_uploaded_file($_FILES['pic_thumb']['tmp_name'], $upload_path . $data['pic_thumb']);
			chmod($upload_path . $data['pic_thumb'], 0644);

			//Resize images if needed
			if ($max_thumbwidth){
				$thumb_size = getimagesize($upload_path . $data['pic_thumb']);
				if ($thumb_size[0] > $max_thumbwidth) {
					image_resize($upload_path . $data['pic_thumb'], $max_thumbwidth, 2);
				}
			}
			if ($max_thumbheight){
				$thumb_size = getimagesize($upload_path . $data['pic_thumb']);
				if ($thumb_size[1] > $max_thumbheight) {
					image_resize($upload_path . $data['pic_thumb'], $max_thumbheight, 3);
				}
			}
		}
	}
	//---------------------------------------

	//Check and move upload full file -------
	if ( !empty($data['pic_full']) && is_uploaded_file($_FILES['pic_full']['tmp_name']) ){
		if (!check_file_type($data['pic_full'])){
			pre_add_product($lang['error_file_type']);
			return false;
		}
		else{
			while ( file_exists($upload_path . $data['pic_full']) ) {
				$data['pic_full'] = str_replace('.', rand(1, 9) . '.', $data['pic_full']);
			}
			move_uploaded_file($_FILES['pic_full']['tmp_name'], $upload_path . $data['pic_full']);
			chmod($upload_path . $data['pic_full'], 0644);

			//Resize images if needed
			if ($max_fullwidth){
				$full_size = getimagesize($upload_path . $data['pic_full']);
				if ($full_size[0] > $max_fullwidth) {
					image_resize($upload_path . $data['pic_full'], $max_fullwidth, 2);
				}
			}
			if ($max_fullheight){
				$full_size = getimagesize($upload_path . $data['pic_full']);
				if ($full_size[1] > $max_fullheight) {
					image_resize($upload_path . $data['pic_full'], $max_fullheight, 3);
				}
			}
		}
	}
	//---------------------------------------------

	//Get max order --------------
	$sql	= "SELECT max(product_order) AS max_order FROM pro";
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ( $db->sql_numrows($result) ){
		$tmp_info	= $db->sql_fetchrow($result);
		$max_order	= $tmp_info['max_order'] + 1;
	}
	else{
		$max_order	= 1;
	}
	//----------------------------

	//Insert product
	$sql	= "INSERT INTO pro(cat_id, title, detail, pic_thumb, pic_full, code, dimension, color, price, product_order, enabled) ";
	$sql	.= " VALUES(". $data['cat_id'] .", '". $data['title'] ."', '". $data['detail'] ."', '". $data['pic_thumb'] ."', '". $data['pic_full'] ."', '". $data['code'] ."', '". $data['dimension'] ."', '". $data['color'] ."', '". $data['price'] ."', $max_order, ". $data['active'] .")";
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	//Update cat counter
	$sql = 'UPDATE pro_cat SET cat_counter=cat_counter+1 WHERE cat_id='. $data['cat_id'];
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	if ($data['pageto'] == 'editpage'){
		$template->assign_vars(array(
			'PAGETO_VALUE'		=> $data['pageto']
		));
		$data = array();//Reset $data
		pre_add_product($lang['success_add']);
	}
	else{
		list_products();
	}
	return true;
}

function pre_edit_product($msg = ""){
	global $lang, $db, $template, $base_url, $template_edit_page, $upload_path, $upload_type, $filter, $start, $data, $site_option;

	$id			= isset($_GET['id']) ? intval($_GET['id']) : 0;
	$currency 	= $site_option['product_currency'];

	$sql = 'SELECT * FROM pro WHERE product_id='. $id;
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ( !$db->sql_numrows($result) ){
		list_products();
		return;
	}
	$product_info = $db->sql_fetchrow($result);

	set_lang_update();
	$template->assign_vars(array(
		"L_ERR_MESSAGE"			=> $msg,
		'S_ACTION'				=> $base_url . '?mode=editsm&id='. $id . $filter['url_append'] .'&start='. $start,
		'CURRENCY'				=> $currency,
		'CATID_VALUE'			=> isset($data['cat_id']) ? $data['cat_id'] : $product_info['cat_id'],
		'CODE_VALUE'			=> isset($data['code']) ? stripslashes($data['code']) : $product_info['code'],
		'DIMENSION_VALUE'		=> isset($data['dimension']) ? stripslashes($data['dimension']) : $product_info['dimension'],
		'COLOR_VALUE'			=> isset($data['color']) ? stripslashes($data['color']) : $product_info['color'],
		'PRICE_VALUE'			=> isset($data['price']) ? stripslashes($data['price']) : floatval($product_info['price']),
		'TITLE_VALUE'			=> isset($data['title']) ? stripslashes($data['title']) : $product_info['title'],
		'DETAIL_VALUE'			=> isset($data['detail']) ? stripslashes($data['detail']) : $product_info['detail'],
		'ACTIVE_VALUE'			=> isset($data['active']) ? $data['active'] : $product_info['enabled'],
		'PIC_THUMB'				=> !empty($product_info['pic_thumb']) ? '<img src="'. $upload_path . $product_info['pic_thumb'] .'">' : '',
		'REMOVE_THUMB'			=> !empty($product_info['pic_thumb']) ? ' &nbsp; <input type="checkbox" name="remove_thumb" value="1"> '. $lang['product_remove_pic'] .'<br />' : '',
		'PIC_FULL'				=> !empty($product_info['pic_full']) ? '<b><a href="javascript: openWin(\''. $base_url .'?mode=full&id='. $id .'\')">'. $product_info['pic_full'] .'</a></b>' : '',
		'REMOVE_FULL'			=> !empty($product_info['pic_full']) ? ' &nbsp; <input type="checkbox" name="remove_full" value="1"> '. $lang['product_remove_pic'] .'<br />' : '',
		'L_PAGE_NAVIGATION'		=> $lang['menu_pro'] . $lang['general_arrow'] . $lang['menu_pro_product'] . $lang['general_arrow'] . $lang['general_edit'],
		'L_SUBMIT'				=> $lang['button_edit'],
	));
	$template->assign_block_vars("editrow", array());

	get_all_cats();
	if (CAT_LEVEL > 1){
		get_sub_cats(0,0,0,"");
	}
	else{
		get_sub_cats(0,0,0,"","");
	}
	show_cats();

	$template->set_filenames(array(
		"body"	=> $template_edit_page
	));
	$template->pparse('body');
}

function do_edit_product(){
	global $db, $template, $base_url, $auth_level, $max_imgwidth, $max_thumbwidth, $max_thumbheight, $max_fullwidth, $max_fullheight, $template_edit_page, $upload_path, $filter, $start;

	$id 					= isset($_GET["id"]) ? intval($_GET["id"]) : 0;
	$data['cat_id']			= isset($_POST["cat_id"]) ? intval($_POST["cat_id"]) : 0;
	$data['pic_thumb']		= isset($_FILES['pic_thumb']['name']) ? htmlspecialchars($_FILES['pic_thumb']['name']) : '';
	$data['remove_thumb']	= isset($_POST["remove_thumb"]) ? intval($_POST["remove_thumb"]) : 0;
	$data['pic_full']		= isset($_FILES['pic_full']['name']) ? htmlspecialchars($_FILES['pic_full']['name']) : '';
	$data['remove_full']	= isset($_POST["remove_full"]) ? intval($_POST["remove_full"]) : 0;
	$data['code']			= isset($_POST["code"]) ? htmlspecialchars($_POST["code"]) : '';
	$data['dimension']		= isset($_POST["dimension"]) ? htmlspecialchars($_POST["dimension"]) : '';
	$data['color']			= isset($_POST["color"]) ? htmlspecialchars($_POST["color"]) : '';
	$data['price']			= isset($_POST["price"]) ? floatval($_POST["price"]) : 0;
	$data['title']			= isset($_POST["title"]) ? htmlspecialchars($_POST["title"]) : '';
	$data['detail']			= isset($_POST["detail"]) ? htmlspecialchars($_POST["detail"]) : '';
	$data['active']			= isset($_POST["active"]) ? intval($_POST["active"]) : 0;
	if (!check_specify_auth($auth_level,'active',0)){
		$data['active'] = 0;
	}
	$data['saveas']		= isset($_POST['saveas']) ? htmlspecialchars($_POST['saveas']) : '';

	$sql_pic_thumb = "";
	$sql_pic_full = "";

	if ( !$data['cat_id'] || empty($data['title']) || ($data['remove_thumb'] && empty($data['pic_thumb'])) ){
		pre_edit_product('Please enter all required fields.');
		return false;
	}

	//Get old info
	$sql = "SELECT cat_id, pic_thumb, pic_full FROM pro WHERE product_id=$id";
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ( !$db->sql_numrows($result) ){
		list_products();
		return false;
	}
	$product_info = $db->sql_fetchrow($result);

	//Check and move upload thumb file --------------
	if ( !empty($data['pic_thumb']) && is_uploaded_file($_FILES['pic_thumb']['tmp_name']) ){
		if ( !check_file_type($data['pic_thumb']) ){
			pre_edit_product('Your file type is not allowed. Please choose another one.');
			return false;
		}
		else{
			//Remove old pic
			if ( ($data['saveas'] != 'copy') && !empty($product_info['pic_thumb']) ){
				@unlink($upload_path . $product_info['pic_thumb']);
			}

			while ( file_exists($upload_path . $data['pic_thumb']) ) {
				$data['pic_thumb'] = str_replace('.', rand(1, 9) . '.', $data['pic_thumb']);
			}
			move_uploaded_file($_FILES['pic_thumb']['tmp_name'], $upload_path . $data['pic_thumb']);
			chmod($upload_path . $data['pic_thumb'], 0644);

			//Resize images if needed
			if ($max_thumbwidth){
				$thumb_size = getimagesize($upload_path . $data['pic_thumb']);
				if ($thumb_size[0] > $max_thumbwidth) {
					image_resize($upload_path . $data['pic_thumb'], $max_thumbwidth, 2);
				}
			}
			if ($max_thumbheight){
				$thumb_size = getimagesize($upload_path . $data['pic_thumb']);
				if ($thumb_size[1] > $max_thumbheight) {
					image_resize($upload_path . $data['pic_thumb'], $max_thumbheight, 3);
				}
			}
			$sql_pic_thumb = ", pic_thumb='". $data['pic_thumb'] ."'";
		}
	}
	else if ($data['remove_thumb']){
		if ( ($data['saveas'] != 'copy') && !empty($product_info['pic_thumb']) ){
			@unlink($upload_path . $product_info['pic_thumb']);
		}
		$sql_pic_thumb = ", pic_thumb=''";
	}
	//-------------------------------------------

	//Check and move upload full file -----------
	if ( !empty($data['pic_full']) && is_uploaded_file($_FILES['pic_full']['tmp_name']) ){
		if (!check_file_type($data['pic_full'])){
			pre_add_product('Your file type is not allowed. Please choose another one.');
			return false;
		}
		else{
			//Remove old pic
			if ( ($data['saveas'] != 'copy') && !empty($product_info['pic_full']) ){
				@unlink($upload_path . $product_info['pic_full']);
			}

			while ( file_exists($upload_path . $data['pic_full']) ) {
				$data['pic_full'] = str_replace('.', rand(1, 9) . '.', $data['pic_full']);
			}
			move_uploaded_file($_FILES['pic_full']['tmp_name'], $upload_path . $data['pic_full']);
			chmod($upload_path . $data['pic_full'], 0644);

			//Resize images if needed
			if ($max_fullwidth){
				$full_size = getimagesize($upload_path . $data['pic_full']);
				if ($full_size[0] > $max_fullwidth) {
					image_resize($upload_path . $data['pic_full'], $max_fullwidth, 2);
				}
			}
			if ($max_fullheight){
				$full_size = getimagesize($upload_path . $data['pic_full']);
				if ($full_size[1] > $max_fullheight) {
					image_resize($upload_path . $data['pic_full'], $max_fullheight, 3);
				}
			}
			$sql_pic_full = ", pic_full='". $data['pic_full'] ."'";
		}
	}
	else if ($data['remove_full']){
		$sql_pic_full = ", pic_full=''";
		if ( ($data['saveas'] != 'copy') && !empty($product_info['pic_full']) ){
			@unlink($upload_path . $product_info['pic_full']);
		}
	}
	//--------------------------------------------------

	if ($data['saveas'] == "copy"){
		//Check and copy picture
		if ( empty($data['pic_thumb']) && !empty($product_info['pic_thumb']) && !$data['remove_thumb'] ){
			$data['pic_thumb']		= $product_info['pic_thumb'];
			while ( file_exists($upload_path . $data['pic_thumb']) ) {
				$data['pic_thumb']	= str_replace('.', rand(1, 9) . '.', $data['pic_thumb']);
			}
			copy($upload_path . $product_info['pic_thumb'], $upload_path . $data['pic_thumb']);
		}
		if ( empty($data['pic_full']) && !empty($product_info['pic_full']) && !$data['remove_full'] ){
			$data['pic_full']		= $product_info['pic_full'];
			while ( file_exists($upload_path . $data['pic_full']) ) {
				$data['pic_full']	= str_replace('.', rand(1, 9) . '.', $data['pic_full']);
			}
			copy($upload_path . $product_info['pic_full'], $upload_path . $data['pic_full']);
		}

		//Get max order ----------
		$sql	= "SELECT max(product_order) AS max_order FROM pro";
		if ( !$result = $db->sql_query($sql) ){
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
		if ( $db->sql_numrows($result) ){
			$tmp_info	= $db->sql_fetchrow($result);
			$max_order	= $tmp_info['max_order'] + 1;
		}
		else{
			$max_order	= 1;
		}
		//-------------------------

		//Insert new product
		$sql = "INSERT INTO pro(cat_id, title, detail, pic_thumb, pic_full, code, dimension, color, price, product_order, enabled) ";
		$sql .= " VALUES(". $data['cat_id'] .", '". $data['title'] ."', '". $data['detail'] ."', '". $data['pic_thumb'] ."', '". $data['pic_full'] ."', '". $data['code'] ."', '". $data['dimension'] ."', '". $data['color'] ."', '". $data['price'] ."', $max_order, ". $data['active'] .")";
		if ( !$result = $db->sql_query($sql) ){
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}

		//Update cat counter
		$sql = 'UPDATE pro_cat SET cat_counter=cat_counter+1 WHERE cat_id='. $data['cat_id'];
		if ( !$result = $db->sql_query($sql) ){
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}
	else{
		if ($data['cat_id'] != $product_info['cat_id']){
			//Update old cat counter
			$sql = 'UPDATE pro_cat SET cat_counter=cat_counter-1 WHERE cat_id='. $product_info['cat_id'];
			if ( !$result = $db->sql_query($sql) ){
				message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
			}

			//Update new cat counter
			$sql = 'UPDATE pro_cat SET cat_counter=cat_counter+1 WHERE cat_id='. $data['cat_id'];
			if ( !$result = $db->sql_query($sql) ){
				message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
			}
		}

		//Update product
		$sql = "UPDATE pro SET cat_id=". $data['cat_id'] .", title='". $data['title'] ."', detail='". $data['detail'] ."'". $sql_pic_thumb . $sql_pic_full .", code='". $data['code'] ."', dimension='". $data['dimension'] ."', color='". $data['color'] ."', price='". $data['price'] ."', enabled=". $data['active'] ." WHERE product_id=$id";
		if ( !$result = $db->sql_query($sql) ){
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	list_products();
	return true;
}

function pre_move_products($msg=""){
	global $lang, $db, $template, $base_url, $template_move_page, $filter, $start;

	$ids	= isset($_POST["ids"]) ? $_POST["ids"] : '';

	if ( !is_array($ids) || !sizeof($ids) ){
		list_products();
		return;
	}

	$template->assign_vars(array(
		'S_ACTION'				=> $base_url . '?mode=movesm'. $filter['url_append'] .'&start='. $start,
		'L_ERR_MESSAGE'			=> $msg,
		'TOTAL_PRODUCTS'		=> sizeof($ids),
		'IDS_VALUE'				=> implode(",", $ids),
		'L_PAGE_NAVIGATION'		=> $lang['menu_pro'] . $lang['general_arrow'] . $lang['menu_pro_product'] . $lang['general_arrow'] . $lang['general_move'],
		'L_TOTAL_PRODUCTS'		=> $lang['products'],
		'L_MOVE_PRODUCT_TO'		=> $lang['product_move_to'],
		'L_SUBMIT'				=> $lang['button_move'],
	));

	get_all_cats();
	if (CAT_LEVEL > 1){
		get_sub_cats(0,0,0,"");
	}
	else{
		get_sub_cats(0,0,0,"","");
	}
	show_cats();

	$template->set_filenames(array(
		"body"	=> $template_move_page
	));
	$template->pparse('body');
	return;
}

function do_move_products(){
	global $db, $template, $base_url, $template_edit_page, $start;

	$dest_id	= isset($_POST['dest_id']) ? intval($_POST['dest_id']) : 0;
	$ids 		= isset($_POST["ids"]) ? htmlspecialchars($_POST["ids"]) : '';

	if ( !$dest_id || empty($ids) ){
		list_products();
		return;
	}

	$product_id	= explode(",", $ids);
	$where_sql	= "WHERE product_id=-1";
	reset($product_id);
	while (list(, $id) = each($product_id)){
		$id = intval(trim($id));
		if ( $id ){
			$where_sql	.= " OR product_id=$id";
		}
	}

	$sql = "UPDATE pro SET cat_id=". $dest_id .' '. $where_sql;
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	resync_cat();
	list_products();
	return true;
}

function resync_cat(){
	global $db, $template_edit_page;

	$sql = 'UPDATE pro_cat SET cat_counter=0';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	$sql = 'SELECT cat_id,count(product_id) AS counter FROM pro GROUP BY cat_id';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$cat_count = $db->sql_numrows($result);
	$cat_data  = $db->sql_fetchrowset($result);

	for ($i=0;$i<$cat_count;$i++){
		$sql = 'UPDATE pro_cat SET cat_counter='. $cat_data[$i]['counter'] .' WHERE cat_id='. $cat_data[$i]['cat_id'];
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}
}

function get_subcat_id($parent_id,&$where_sql){
	global $cat_data, $sort_catdata;

	$tmpcat = $cat_data;
	if (!isset($tmpcat['parent_id']) || !is_array($tmpcat['parent_id']) ) return false;

	reset($tmpcat);
	while (list($key, $pid) = each($tmpcat['parent_id'])){
		if ($pid == $parent_id){
			$where_sql .= ' OR cat_id='. $tmpcat["cat_id"][$key];
			get_sub_cats($tmpcat["cat_id"][$key], $where_sql);
		}
	}

	return true;
}

function get_all_cats(){
	global $db, $cat_data, $template, $sort_catdata;

	//Get all cats
	$sql = 'SELECT * FROM pro_cat ORDER BY cat_order ASC';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	if ($db->sql_numrows($result)){
		while ($tmpcat_info = $db->sql_fetchrow($result)){
			$cat_data['cat_id'][] 		= $tmpcat_info['cat_id'];
			$cat_data['parent_id'][] 	= $tmpcat_info['cat_parent_id'];
			$cat_data['cat_title'][] 	= $tmpcat_info['cat_title'];
			$cat_data['cat_counter'][] 	= $tmpcat_info['cat_counter'];
		}
	}
	$db->sql_freeresult($result);
}

function get_sub_cats($parent_id, $level, $cid=0, $str="", $prefix="|-- "){
	global $cat_data, $sort_catdata;

	$tmpcat = $cat_data;
	if (!isset($tmpcat['parent_id']) || !is_array($tmpcat['parent_id']) ) return false;

	reset($tmpcat);
	while (list($key, $pid) = each($tmpcat['parent_id'])){
		if ( $cid == $tmpcat['cat_id'][$key] ) continue;

		if ($pid == $parent_id){
			$sort_catdata["cat_id"][]		= $tmpcat["cat_id"][$key];
			$sort_catdata["cat_title"][]	= $str .$prefix. $tmpcat["cat_title"][$key];
			$str2							= $str . "&nbsp; &nbsp; &nbsp;";
			$sort_catdata["cat_counter"][]	= $tmpcat["cat_counter"][$key];

			if ( ($level==-1) || ($level < CAT_LEVEL - 1) ){
				get_sub_cats($tmpcat["cat_id"][$key], $level+1, $cid, $str2, $prefix);
			}
		}
	}

	return true;
}

function get_sub_cats_2($parent_id, $level, $cid=0, $str=""){
	global $cat_data, $sort_catdata;

	$tmpcat = $cat_data;
	if (!isset($tmpcat['parent_id']) || !is_array($tmpcat['parent_id']) ) return false;

	reset($tmpcat);
	while (list($key, $pid) = each($tmpcat['parent_id'])){
		if ( $cid == $tmpcat['cat_id'][$key] ) continue;

		if ($pid == $parent_id){
			$sort_catdata["cat_id"][] 		= $tmpcat["cat_id"][$key];
			$sort_catdata["cat_title"][] 	= $str . $tmpcat["cat_title"][$key];
			$sort_catdata["cat_counter"][] 	= $tmpcat["cat_counter"][$key];
			if ( ($level==-1) || ($level < CAT_LEVEL - 1) ){
				$str2 = $str . $tmpcat["cat_title"][$key] . "/";
				get_sub_cats_2($tmpcat["cat_id"][$key], $cid, $level+1, $str2);
			}
		}
	}

	return true;
}

function show_cats(){
	global $db, $cat_data, $template, $sort_catdata;

	if ( !isset($sort_catdata['cat_id']) || !is_array($sort_catdata['cat_id'])) return false;

	reset($sort_catdata['cat_id']);
	while (list($key, $id) = each($sort_catdata['cat_id'])){
		$template->assign_block_vars("catrow",array(
			'CAT_ID'		=> $id,
			'CAT_TITLE'		=> $sort_catdata['cat_title'][$key],
		));
	}

	return true;
}

function active_products(){
	global $template, $db, $base_url, $template_edit_page;

	$flag 	= isset($_POST["factive"]) ? htmlspecialchars($_POST["factive"]) : 'disable';
	$ids  	= isset($_POST["ids"]) ? $_POST["ids"] : '';

	if ( is_array($ids) ){
		$active		= ($flag == "enable") ? 1 : 0;
		$sql		= 'UPDATE pro SET enabled=' . $active . ' WHERE product_id=-1';
		while (list(, $id) = each($ids)){
			$id		= intval($id);
			if ( $id ){
				$sql	.= ' OR product_id=' . $id;
			}
		}
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	list_products();
}

function delete_products(){
	global $template, $db, $base_url, $template_edit_page, $upload_path;

	$ids	= isset($_POST["ids"]) ? $_POST["ids"] : '';

	if ( is_array($ids) ){
		$where_sql	= 'product_id=-1';
		while (list(, $id) = each($ids)){
			$id		= intval($id);
			if ( $id ){
				$where_sql .= ' OR product_id='. $id;
			}
		}

		//Update cat counter -----------
		$sql = 'SELECT count(product_id) AS total, cat_id FROM pro WHERE '. $where_sql .' GROUP BY cat_id';
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
		$cat_count = $db->sql_numrows($result);
		$cat_data = $db->sql_fetchrowset($result);
		$db->sql_freeresult($result);

		for ($i=0;$i<$cat_count;$i++){
			$sql = 'UPDATE pro_cat SET cat_counter=cat_counter-'. $cat_data[$i]['total'] .' WHERE cat_id='. $cat_data[$i]['cat_id'];
			if ( !$result = $db->sql_query($sql) ) {
				message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
			}
		}
		//-------------------------------

		//Get and Delete pictures -------
		$sql = 'SELECT pic_thumb, pic_full FROM pro WHERE '. $where_sql;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
		$thumb_count	= $db->sql_numrows($result);
		$thumb_data		= $db->sql_fetchrowset($result);
		for ($i=0;$i<$thumb_count;$i++){
			if ( !empty($thumb_data[$i]['pic_thumb']) ){
				@unlink($upload_path . $thumb_data[$i]['pic_thumb']);
			}
			if ( !empty($thumb_data[$i]['pic_full']) ){
				@unlink($upload_path . $thumb_data[$i]['pic_full']);
			}
		}
		$db->sql_freeresult($result);
		//--------------------------------

		$sql = 'DELETE FROM pro WHERE '. $where_sql;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	list_products();
}

function view_product(){
	global $lang, $db, $template, $template_view_page, $image_path, $site_base_href, $site_option;

	$id			= isset($_GET['id']) ? intval($_GET['id']) : 0;
	$currency 	= $site_option['product_currency'];

	$sql = 'SELECT * FROM pro WHERE product_id='. $id;
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ( !$db->sql_numrows($result) ){
		die('Not exist this product.');
	}
	$product_info = $db->sql_fetchrow($result);

	$template->assign_vars(array(
		'CURRENCY'			=> $currency,
		'CODE_VALUE'		=> restore_htmltags(nl2br($product_info['code'])),
		'DIMENSION_VALUE'	=> $product_info['dimension'],
		'COLOR_VALUE'		=> $product_info['color'],
		'PRICE_VALUE'		=> $product_info['price'] ? number_format($product_info['price'], DECIMALS, DEC_POINT, THOUSANDS_SEP) .' '. $currency : '',
		'TITLE_VALUE'		=> restore_htmltags(nl2br($product_info['title'])),
		'DETAIL_VALUE'		=> restore_htmltags(nl2br($product_info['detail'])),
		'PIC_FULL'			=> !empty($product_info['pic_full']) ? '<img src="'. $image_path . $product_info['pic_full'] .'" border="0">' : '',
		'L_CODE'			=> $lang['product_code'],
		'L_DIMENSION'		=> $lang['product_dimension'],
		'L_COLOR'			=> $lang['product_color'],
		'L_PRICE'			=> $lang['product_price'],
	));

	$template->set_filenames(array(
		"body"	=> $template_view_page
	));
	$template->pparse('body');
}

function view_picture($pic){
	global $db, $template, $base_url, $template_picture_page, $upload_path;

	$id		= isset($_GET['id']) ? intval($_GET['id']) : 0;

	$sql = 'SELECT '. $pic .' AS picture FROM pro WHERE product_id='. $id;
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ( !$db->sql_numrows($result) ){
		die('Not exist this picture');
		return;
	}
	$product_info = $db->sql_fetchrow($result);

	$template->assign_vars(array(
		'PICTURE'		=> !empty($product_info['picture']) ? '<img src="'. $upload_path . $product_info['picture'] .'" border="0">' : '',
	));

	$template->set_filenames(array(
		"body"	=> $template_picture_page
	));
	$template->pparse('body');
}

function update_orders(){
	global $db, $template;

	$orders		= isset($_POST['orders']) ? $_POST['orders'] : '';
	if ( is_array($orders) ){
		while (list($id, $order) = each($orders)){
			$id		= intval($id);
			$order	= intval($order);
			if ( $id && $order ){
				$sql	= "UPDATE pro SET product_order=$order WHERE product_id=$id";
				if ( !$result = $db->sql_query($sql) ){
					message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
				}
			}
		}
	}

	list_products();
}

function resync_orders(){
	global $db;

	//Get all products
	$sql	= "SELECT product_id, product_order FROM pro ORDER BY code ASC";
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$product_count	= $db->sql_numrows($result);
	$product_data	= $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	$count	= 1;
	for ($i=0; $i<$product_count; $i++){
		$sql	= "UPDATE pro SET product_order=$count WHERE product_id=". $product_data[$i]['product_id'];
		if ( !$result = $db->sql_query($sql) ){
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
		$count++;
	}
	list_products();
}
?>