

<?php
define('IN_SITE', true);
define("CAT_LEVEL", 1);
include("common.php");

$base_url				= 'pro_cat.php';
$base_product_url		= 'pro.php';
$template_edit_page		= "pro_cat_edit.tpl";
$template_move_page		= "pro_cat_move.tpl";
$template_del_page		= "pro_cat_del.tpl";
$template_body_page 	= "pro_cat_body.tpl";
$upload_path 			= "../images/product_cat/";
$upload_pro_path		= "../images/pro/";

$auth_level = check_any_auth($base_url);

//----------------- IMAGE SIZE -------------------
$max_imgwidth 	= 220;//Limit width is 150
$max_imgheight 	= 120;//0: Not limit
if ($max_imgwidth && $max_imgheight){
	$imgsize	= sprintf($lang['general_pic_size'], $max_imgwidth .' x '. $max_imgheight);
}
else if ($max_imgwidth){
	$imgsize	= sprintf($lang['general_pic_width'], $max_imgwidth);
}
else if ($max_imgheight){
	$imgsize	= sprintf($lang['general_pic_height'], $max_imgheight);
}
else{
	$imgsize	= "";
}
$template->assign_vars(array(
	'IMGSIZE'	=> $imgsize
));
//------------------------------------------------

$cat_data		= array();
$sort_catdata 	= array();
$start			= isset($_GET['start']) ? intval($_GET['start']) : 0;
$mode			= isset($_GET["mode"]) ? htmlspecialchars($_GET["mode"]) : '';
switch ($mode){
	case "add":
		check_specify_auth($auth_level,'add');
		pre_add_cat();
		break;
	case "addsm":
		check_specify_auth($auth_level,'add');
		do_add_cat();
		break;
	case "edit":
		check_specify_auth($auth_level,'edit');
		pre_edit_cat();
		break;
	case "editsm":
		check_specify_auth($auth_level,'edit');
		do_edit_cat();
		break;
	case "move":
		check_specify_auth($auth_level,'edit');
		pre_move_products();
		break;
	case "movesm":
		check_specify_auth($auth_level,'edit');
		do_move_products();
		break;
	case "del":
		check_specify_auth($auth_level,'delete');
		pre_delete_cat();
		break;
	case "delsm":
		check_specify_auth($auth_level,'delete');
		do_delete_cat();
		break;
	case "up":
		check_specify_auth($auth_level,'edit');
		bring_up_cat();
		break;
	case "down":
		check_specify_auth($auth_level,'edit');
		bring_down_cat();
		break;
	case "resync":
		check_specify_auth($auth_level,'edit');
		resync_cat();
		break;
	default:
		list_cats();
}

function list_cats(){
	global $lang, $template, $cat_data, $site_option, $auth_level, $sort_catdata, $base_url, $base_product_url, $template_body_page, $start, $user_info;

	$itemperpage = $site_option['items_per_page'];

	$cat_data		= array();
	$sort_catdata	= array();
	get_all_cats();
	if (CAT_LEVEL > 1){
		get_sub_cats(0,0,1,0,"");
	}
	else{
		get_sub_cats(0,0,1,0,"","");
	}

	if ($user_info['user_level'] == SYSTEM_ADMIN){
		$auth_add		= 1;
		$auth_edit 		= 1;
		$auth_delete 	= 1;
		$auth_active 	= 1;
	}
	else{
		$auth_add 		= check_specify_auth($auth_level,'add',0) ? 1 : 0;
		$auth_edit 		= check_specify_auth($auth_level,'edit',0) ? 1 : 0;
		$auth_delete 	= check_specify_auth($auth_level,'delete',0) ? 1 : 0;
		$auth_active 	= check_specify_auth($auth_level,'active',0) ? 1 : 0;
	}

	//Show cats
	$count		= 0;
	$max_count	= $start + $itemperpage;
	if ( isset($sort_catdata['cat_id']) && is_array($sort_catdata['cat_id']) ){
		reset($sort_catdata['cat_id']);
		while (list($key, $id) = each($sort_catdata['cat_id'])){
			if ($count < $start){
				$count++;
				continue;
			}
			$template->assign_block_vars("catrow", array(
				'CAT_ID'			=> $id,
				'PIC_THUMB'			=> (!empty($sort_catdata['pic_thumb'][$key])) ? '<img src="./images/pic.gif"> ' : "",
				'TITLE_PREFIX'		=> $sort_catdata['title_prefix'][$key],
				'CAT_TITLE'			=> $sort_catdata['cat_title'][$key],
				'CAT_CSS'			=> ($sort_catdata['level'][$key] < CAT_LEVEL) ? 'enabled' : 'disabled',
				'CAT_COUNTER'		=> $sort_catdata['cat_counter'][$key] ? '<a href="'. $base_product_url .'?fcat_id='. $sort_catdata['cat_id'][$key] .'">'. $sort_catdata['cat_counter'][$key] .' <img src="images/counter.gif" border="0"></a>' : $sort_catdata['cat_counter'][$key],
				'U_CAT_UP'			=> $auth_edit ? '<a href="'. $base_url .'?mode=up&cid='. $id .'&start='. $start .'"><img src=images/up.gif width=16 height=16 alt="'. $lang['general_up'] .'" border=0>' : '&nbsp;',
				'U_CAT_EDIT'		=> $auth_edit ? '<a href="'. $base_url .'?mode=edit&cid='. $id .'&start='. $start .'"><img src=images/edit.gif width=16 height=16 alt="'. $lang['general_edit'] .'" border=0></a>' : '&nbsp;',
				'U_CAT_DOWN'		=> $auth_edit ? '<a href="'. $base_url .'?mode=down&cid='. $id .'&start='. $start .'"><img src=images/down.gif width=16 height=16 alt="'. $lang['general_down'] .'" border=0></a>' : '&nbsp;',
				'U_MOVE_PRODUCTS'	=> $auth_edit ? '<a href="'. $base_url .'?mode=move&cid='. $id .'&start='. $start .'"><img src=images/move.gif width=20 height=14 alt="'. $lang['product_move'] .'" border=0></a>' : '&nbsp;',
				'U_CAT_DEL'			=> $auth_delete ? '<a href="'. $base_url .'?mode=del&cid=' . $id .'&start='. $start .'"><img src=images/del.gif width=16 height=16 alt="'. $lang['general_del'] .'" border=0></a>' : '&nbsp;',
			));
			$count++;
			if ($count >= $max_count) break;
		}
	}

	$total_count	= isset($sort_catdata['cat_id']) ? sizeof($sort_catdata['cat_id']) : 0;
	$pagination		= pagination($base_url . "?", $total_count, $itemperpage, $start, 'start', $lang['general_page'] .': //<img src="images/prev.gif" border="0">//<img src="images/next.gif" border="0">')."&nbsp;";

	$template->assign_vars(array(
		'NAVIGATOR'				=> $pagination,
		'U_NEW_CAT'				=> ($auth_add) ? '<a href="'. $base_url .'?mode=add"><img src="images/new.gif" width="20" height="14" alt="'. $lang['general_new'] .'" border="0" align="absbottom">'. $lang['general_new'] .'</a>' : '&nbsp;',
		'U_RESYNC'				=> ($auth_edit) ? '<a href="'. $base_url .'?mode=resync&start='. $start .'"><img src="images/resynce.gif" width="20" height="14" alt="'. $lang['general_resync'] .'" border="0" align="absbottom">'. $lang['general_resync'] .'</a>' : '&nbsp;',
		'U_MOVE'				=> ($auth_edit) ? '<a href="javascript: updateForm(\''. $base_url . '?mode=move&start='. $start .'\');"><img src=images/move.gif width=20 height=14 alt="'. $lang['product_move'] .'" border=0 align="absbottom">'. $lang['product_move'] .'</a>' : '&nbsp;',
		'L_PAGE_NAVIGATION'		=> $lang['menu_pro'] . $lang['general_arrow'] . $lang['menu_pro_cat'],
		'L_CAT_TITLE'			=> $lang['general_cat_title'],
		'L_COUNTER'				=> $lang['products'],
		'L_ORDER'				=> $lang['general_order'],
		'L_EDIT'				=> $lang['general_edit'],
		'L_DEL'					=> $lang['general_del'],
		'L_CHOOSE_CAT'			=> $lang['error_procat_not_choose'],
	));

	$template->set_filenames(array(
		"body"	=> $template_body_page
	));
	$template->pparse('body');
}

function pre_add_cat($msg = ""){
	global $lang, $template, $base_url, $template_edit_page;

	$template->assign_vars(array(
		'S_ACTION'				=> $base_url . '?mode=addsm',
		'L_ERR_MESSAGE'			=> $msg,
		'L_PAGE_NAVIGATION'		=> $lang['menu_pro'] . $lang['general_arrow'] . $lang['menu_pro_cat'] . $lang['general_arrow'] . $lang['general_new'],
		'L_ROOT'				=> $lang['general_root'],
		'L_PARENT_CAT'			=> $lang['general_parent_cat'],
		'L_PICTURE'				=> $lang['general_pic_thumb'],
		'L_CAT_TITLE'			=> $lang['general_cat_title'],
		'L_SUBMIT'				=> $lang['button_new'],
	));
	if (CAT_LEVEL > 1){
		get_all_cats();
		get_sub_cats(0,1,0,0,"");
		show_cats();
	}

	$template->set_filenames(array(
		"body"	=> $template_edit_page
	));
	$template->pparse('body');
}

function do_add_cat(){
	global $lang, $db, $template, $base_url, $template_edit_page, $upload_path, $max_imgwidth, $max_imgheight;

	$parent_id	= isset($_POST['parent_id']) ? intval($_POST['parent_id']) : 0;
	$pic_thumb	= isset($_FILES['pic_thumb']['name']) ? htmlspecialchars($_FILES['pic_thumb']['name']) : '';
	$cat_title	= isset($_POST['cat_title']) ? htmlspecialchars($_POST['cat_title']) : '';

	if (empty($cat_title)){
		pre_add_cat($lang['error_no_cat_title']);
		return false;
	}

	//Check exist
	$sql	= "SELECT cat_id FROM pro_cat WHERE cat_title='". $cat_title ."'";
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ( $db->sql_numrows($result) ){
		pre_add_cat($lang['error_procat_exist']);
		return false;
	}

	//Get max order
	$sql = 'SELECT max(cat_order) AS max_order FROM pro_cat WHERE cat_parent_id='. $parent_id;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result)){
		$order_info	= $db->sql_fetchrow($result);
		$max_order	= $order_info['max_order'] + 1;
	}
	else{
		$max_order	= 1;
	}
	$db->sql_freeresult($result);

	//Check and move upload thumb file
	if ( !empty($pic_thumb) && is_uploaded_file($_FILES['pic_thumb']['tmp_name']) ){
		if (!check_file_type($pic_thumb)){
			pre_add_cat($lang['error_file_type']);
			return false;
		}
		else{
			while ( file_exists($upload_path . $pic_thumb) ) {
				$pic_thumb = str_replace('.', rand(1, 9) . '.', $pic_thumb);
			}
			move_uploaded_file($_FILES['pic_thumb']['tmp_name'], $upload_path . $pic_thumb);
			chmod($upload_path . $pic_thumb, 0644);

			//Resize images if needed
			if ($max_imgwidth){
				$thumb_size = getimagesize($upload_path . $pic_thumb);
				if ($thumb_size[0] > $max_imgwidth) {
					image_resize($upload_path . $pic_thumb, $max_imgwidth, 2);
				}
			}
			if ($max_imgheight){
				$thumb_size = getimagesize($upload_path . $pic_thumb);
				if ($thumb_size[1] > $max_imgheight) {
					image_resize($upload_path . $pic_thumb, $max_imgheight, 3);
				}
			}
		}
	}

	$sql = "INSERT INTO pro_cat(cat_parent_id, cat_title, pic_thumb, cat_order, cat_counter) VALUES($parent_id, '". $cat_title ."', '". $pic_thumb ."', $max_order, 0)";
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	list_cats();
	return true;
}

function pre_edit_cat($msg = ""){
	global $lang, $db, $template, $base_url, $template_edit_page, $upload_path, $start;

	$cid = isset($_GET["cid"]) ? intval($_GET["cid"]) : 0;

	$sql = 'SELECT * FROM pro_cat WHERE cat_id='. $cid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ( !$db->sql_numrows($result) ){
		list_cats();
		return;
	}
	$cat_info = $db->sql_fetchrow($result);

	$template->assign_vars(array(
		'S_ACTION'			=> $base_url . '?mode=editsm&cid='. $cat_info['cat_id'] .'&start='. $start,
		'L_ERR_MESSAGE'		=> $msg,
		'PARENTID_VALUE'	=> $cat_info['cat_parent_id'],
		'TITLE_VALUE'		=> $cat_info['cat_title'],
		'PIC_THUMB'			=> (!empty($cat_info['pic_thumb'])) ? '<img src="'. $upload_path . $cat_info['pic_thumb'] .'">' : '',
		'REMOVE_THUMB'		=> (!empty($cat_info['pic_thumb'])) ? '<input type="checkbox" name="remove_thumb" value="1"> Remove<br />' : '',
		'L_ERR_MESSAGE'		=> $msg,
		'L_ROOT'			=> $lang['general_root'],
		'L_PAGE_NAVIGATION'	=> $lang['menu_pro'] . $lang['general_arrow'] . $lang['menu_pro_cat'] . $lang['general_arrow'] . $lang['general_edit'],
		'L_PARENT_CAT'		=> $lang['general_parent_cat'],
		'L_PICTURE'			=> $lang['general_pic_thumb'],
		'L_CAT_TITLE'		=> $lang['general_cat_title'],
		'L_SUBMIT'			=> $lang['button_edit'],
	));

	if (CAT_LEVEL > 1){
		get_all_cats();
		get_sub_cats(0,1,0, $cid,"");
		show_cats();
	}

	$template->set_filenames(array(
		"body"	=> $template_edit_page
	));
	$template->pparse('body');
}

function do_edit_cat(){
	global $lang, $db, $template, $base_url, $template_edit_page, $upload_path, $max_imgwidth, $max_imgheight, $start;

	$cid			= isset($_GET['cid']) ? intval($_GET['cid']) : 0;
	$parent_id 		= isset($_POST['parent_id']) ? intval($_POST['parent_id']) : 0;
	$pic_thumb		= isset($_FILES['pic_thumb']['name']) ? htmlspecialchars($_FILES['pic_thumb']['name']) : '';
	$remove_thumb	= isset($_POST["remove_thumb"]) ? intval($_POST["remove_thumb"]) : 0;
	$cat_title		= isset($_POST['cat_title']) ? htmlspecialchars($_POST['cat_title']) : '';

	if (empty($cat_title)){
		pre_edit_cat($lang['error_no_cat_title']);
		return false;
	}

	//Check exist
	$sql	= "SELECT cat_id FROM pro_cat WHERE cat_title='". $cat_title ."' AND cat_id!=$cid";
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ( $db->sql_numrows($result) ){
		pre_edit_cat($lang['error_procat_exist']);
		return false;
	}

	$sql_pic_thumb = "";
	//Check and move upload thumb file
	if (!empty($pic_thumb)&&is_uploaded_file($_FILES['pic_thumb']['tmp_name'])){
		if (!check_file_type($pic_thumb)){
			pre_edit_cat($lang['error_file_type']);
			return false;
		}
		else{
			remove_pic_thumb($cid);//Remove old picture
			
			//Upload new picture
			while ( file_exists($upload_path . $pic_thumb) ) {
				$pic_thumb = str_replace('.', rand(1, 9) . '.', $pic_thumb);
			}
			move_uploaded_file($_FILES['pic_thumb']['tmp_name'], $upload_path . $pic_thumb);
			chmod($upload_path . $pic_thumb, 0644);

			//Resize images if needed
			if ($max_imgwidth){
				$thumb_size = getimagesize($upload_path . $pic_thumb);
				if ($thumb_size[0] > $max_imgwidth) {
					image_resize($upload_path . $pic_thumb, $max_imgwidth, 2);
				}
			}
			if ($max_imgheight){
				$thumb_size = getimagesize($upload_path . $pic_thumb);
				if ($thumb_size[1] > $max_imgheight) {
					image_resize($upload_path . $pic_thumb, $max_imgheight, 3);
				}
			}
			$sql_pic_thumb = ", pic_thumb='". $pic_thumb ."'";
		}
	}
	else if ($remove_thumb){
		remove_pic_thumb($cid);
		$sql_pic_thumb = ", pic_thumb=''";
	}

	$sql = "UPDATE pro_cat SET cat_parent_id=". $parent_id .", cat_title='". $cat_title ."'". $sql_pic_thumb ." WHERE cat_id=$cid";
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	list_cats();
	return true;
}

function pre_move_products($msg = ""){
	global $lang, $db, $template, $base_url, $template_move_page, $start;

	$catid = isset($_POST["catid"]) ? $_POST["catid"] : 0;

	if ( !is_array($catid) || !sizeof($catid) ){
		list_cats();
		return;
	}

	$cat_str	= "";
	$where_sql  = "WHERE cat_id=-1";
	reset($catid);
	while (list($id,) = each($catid)){
		$id = intval($id);
		if ($id){
			$where_sql	.= " OR cat_id=$id";
			$cat_str	.= !empty($cat_str) ?  ", $id" : $id;
		}
	}

	$sql = 'SELECT * FROM pro '. $where_sql;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$pro_count	= $db->sql_numrows($result);
	$pro_data	= $db->sql_fetchrowset($result);

	if ( !$pro_count ){
		list_cats();
		return;
	}

	$template->assign_vars(array(
		'S_ACTION'				=> $base_url . '?mode=movesm&start='. $start,
		'TOTAL_PRODUCTS'		=> $pro_count,
		'CATID_VALUE'			=> $cat_str,
		'L_ERR_MESSAGE'			=> $msg,
		'L_PAGE_NAVIGATION'		=> $lang['menu_pro'] . $lang['general_arrow'] . $lang['menu_pro_cat'] . $lang['general_arrow'] . $lang['product_move'],
		'L_MOVE_PRODUCT'		=> $lang['product_move'],
		'L_TOTAL_PRODUCTS'		=> $lang['products'],
		'L_MOVE_PRODUCT_TO'		=> $lang['product_move_to'],
		'L_SUBMIT'				=> $lang['button_move'],
	));

	get_all_cats();
	if (CAT_LEVEL > 1){
		get_sub_cats(0,0,"");
	}
	else{
		get_sub_cats(0,0,0, $catid,"");
	}
	show_cats();

	$template->set_filenames(array(
		"body"	=> $template_move_page
	));
	$template->pparse('body');
	return;
}

function do_move_products(){
	global $db, $template, $base_url, $template_edit_page, $start;

	$dest_id	= isset($_POST['dest_id']) ? intval($_POST['dest_id']) : 0;
	$cid 		= isset($_POST["catid"]) ? htmlspecialchars($_POST["catid"]) : '';

	if ( !$dest_id || empty($cid) ){
		list_cats();
		return;
	}

	$catid = explode(",", $cid);
	if (is_array($catid)){
		$where_sql  = "WHERE cat_id=-1";
		reset($catid);
		while (list(, $id) = each($catid)){
			$id = intval($id);
			if ($id){
				$where_sql	.= " OR cat_id=$id";
			}
		}
	}
	else{
		$where_sql = "WHERE cat_id=". intval($cid);
	}

	$sql = "UPDATE pro SET cat_id=". $dest_id .' '. $where_sql;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	resync_cat();
	return true;
}

function remove_pic_thumb($cat_id){
	global $db, $upload_path;

	$sql = 'SELECT pic_thumb FROM pro_cat WHERE cat_id='. $cat_id;
	if ( !$result = $db->sql_query($sql) )
	{
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result))
	{
		$cat_info = $db->sql_fetchrow($result);
		if (!empty($cat_info['pic_thumb']))
		{
			@unlink($upload_path . $cat_info['pic_thumb']);
		}
	}
}

function pre_delete_cat($msg=""){
	global $lang, $db, $template, $base_url, $template_del_page, $upload_path, $start;

	$cid = isset($_GET["cid"]) ? intval($_GET["cid"]) : 0;

	get_all_cats();
	if (CAT_LEVEL > 1){
		get_sub_cats(0,0,0, $cid,"");
	}
	else{
		get_sub_cats(0,0,0, $cid,"","");
	}
	show_cats();

	$sql = 'SELECT * FROM pro_cat WHERE cat_id='. $cid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if (!$db->sql_numrows($result))
	{
		list_cats();
		return;
	}
	$cat_info = $db->sql_fetchrow($result);

	//Check products
	$sql = 'SELECT product_id FROM pro WHERE cat_id='. $cid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result))
	{
		$pro = 1;
	}
	else{
		$pro = 0;
	}

	//Check subcat
	$subcat	= 0;
	$subpro	= 0;
	count_subcats($subcat, $subpro, $cid);

	$template->assign_vars(array(
		'S_ACTION'					=> $base_url . '?mode=delsm&cid='. $cat_info['cat_id'] .'&start='. $start,
		'L_ERR_MESSAGE'				=> $msg,
		'TITLE_VALUE'				=> $cat_info['cat_title'],
		'PRO_COUNTER'				=> $cat_info['cat_counter'],
		'SUBCAT_COUNTER'			=> $subcat,
		'SUBPRO_COUNTER'			=> $subpro,
		'PRO_DISPLAY'				=> ($pro) ? 'block' : 'none',
		'SUBCAT_DISPLAY'			=> ($subcat) ? 'block' : 'none',
		'SUBPRO_DISPLAY'			=> ($subpro) ? 'block' : 'none',
		'L_PAGE_NAVIGATION'			=> $lang['menu_pro'] . $lang['general_arrow'] . $lang['menu_pro_cat'] . $lang['general_arrow'] . $lang['general_del'],
		'L_PRO_OF_CAT'				=> $lang['product_of_cat'],
		'L_CAT_TITLE'				=> $lang['general_cat_title'],
		'L_SUBCATS'					=> $lang['general_subcats'],
		'L_PRO_OF_SUBCATS'			=> $lang['product_of_subcats'],
		'L_DEL_PRODUCTS'			=> $lang['general_del'] .' '. $lang['products'],
		'L_DEL_SUBCATS'				=> $lang['general_del'] .' '. $lang['general_subcats'],
		'L_DEL_PRO_OF_CAT'			=> $lang['product_del_of_cat'],
		'L_MOVE_PRO_OF_CAT'			=> $lang['product_move_of_cat'],
		'L_DEL_PRO_OF_SUBCATS'		=> $lang['product_del_of_subcats'],
		'L_MOVE_PRO_OF_SUBCATS'		=> $lang['product_move_of_subcats'],
		'L_DEL_ALL_SUBCATS'			=> $lang['product_del_subcats'],
		'L_MOVE_ALL_SUBCATS'		=> $lang['product_move_subcats'],
		'L_SUBMIT'					=> $lang['button_del'],
	));

	$template->set_filenames(array(
		"body"	=> $template_del_page
	));
	$template->pparse('body');
}

function count_subcats(&$cat_count,&$pro_count, $cid){
	global $cat_data;

	if (isset($cat_data['parent_id']) && is_array($cat_data['parent_id'])){
		$tmpcat		= $cat_data['parent_id'];
		reset($tmpcat);
		while ( list($key, $pid) = each($tmpcat) ){
			if ($pid == $cid){
				$cat_count++;
				$pro_count += isset($cat_data['cat_counter'][$key]) ? $cat_data['cat_counter'][$key] : 0;
				
				$cat_id = isset($cat_data['cat_id'][$key]) ? $cat_data['cat_id'][$key] : 0;
				if ($cat_id){
					count_subcats($cat_count, $pro_count, $cat_id);
				}
			}
		}
	}
}

function do_delete_cat(){
	global $db, $template, $base_url, $template_edit_page, $upload_path, $upload_pro_path;

	$cid			= isset($_GET['cid']) ? intval($_GET['cid']) : 0;
	$procatmove		= isset($_POST['procatmove']) ? htmlspecialchars($_POST['procatmove']) : '';
	$cat_id			= isset($_POST['cat_id']) ? intval($_POST['cat_id']) : 0;
	$submove		= isset($_POST['submove']) ? htmlspecialchars($_POST['submove']) : '';
	$prosubmove		= isset($_POST['prosubmove']) ? htmlspecialchars($_POST['prosubmove']) : '';
	$subcat_id		= isset($_POST['subcat_id']) ? intval($_POST['subcat_id']) : 0;
	$cat_parent_id	= isset($_POST['cat_parent_id']) ? intval($_POST['cat_parent_id']) : 0;

	if ( ($procatmove == 'move') && $cat_id ){
		//Move all products of this cat
		$sql = "UPDATE pro SET cat_id=$cat_id WHERE cat_id=$cid";
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}
	else{
		//Delete all picture of products
		$sql = 'SELECT pic_thumb,pic_full FROM pro WHERE cat_id='. $cid;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
		$picture_count = $db->sql_numrows($result);
		$picture_data = $db->sql_fetchrowset($result);
		$db->sql_freeresult($result);

		for ($i=0;$i<$picture_count;$i++){
			if ( !empty($picture_data[$i]['pic_thumb']) ){
				@unlink($upload_pro_path . $picture_data[$i]['pic_thumb']);
			}
			if ( !empty($picture_data[$i]['pic_full']) ){
				@unlink($upload_pro_path . $picture_data[$i]['pic_full']);
			}
		}

		//Delete all products in this cat
		$sql = 'DELETE FROM pro WHERE cat_id='. $cid;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	if ( ($submove == "move") && ($cat_parent_id) ){
		//Move all sub categories of this cat
		$sql = "UPDATE pro_cat SET cat_parent_id_id=$cat_parent_id WHERE cat_parent_id=$cid";
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}
	else{
		//Get all sub cats
		get_all_cats();
		$where_sql = " cat_id=-1";
		get_sub_cat_id($cid, $where_sql);
		
		if ( $prosubmove == "move" ){
			//Move all products of sub cats
			$sql = "UPDATE pro SET cat_id=$subcat_id WHERE $where_sql";
			if ( !$result = $db->sql_query($sql) ) {
				message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
			}
		}
		else{
			//Get and delete all pictures of products in these cats
			$sql = 'SELECT pic_thumb,pic_full FROM pro WHERE '. $where_sql;
			if ( !$result = $db->sql_query($sql) ) {
				message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
			}
			$picture_count = $db->sql_numrows($result);
			$picture_data = $db->sql_fetchrowset($result);
			$db->sql_freeresult($result);

			for ($i=0;$i<$picture_count;$i++){
				if ( !empty($picture_data[$i]['pic_thumb']) ){
					@unlink($upload_pro_path . $picture_data[$i]['pic_thumb']);
				}
				if ( !empty($picture_data[$i]['pic_full']) ){
					@unlink($upload_pro_path . $picture_data[$i]['pic_full']);
				}
			}

			//Delete all products in these cats
			$sql = 'DELETE FROM pro WHERE '. $where_sql;
			if ( !$result = $db->sql_query($sql) ) {
				message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
			}
		}
		
		//Get and delete all pictures of these sub cats
		$sql = 'SELECT pic_thumb FROM pro_cat WHERE '. $where_sql;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
		$picture_count = $db->sql_numrows($result);
		$picture_data = $db->sql_fetchrowset($result);
		$db->sql_freeresult($result);

		for ($i=0; $i<$picture_count; $i++){
			if ( !empty($picture_data[$i]['pic_thumb']) ){
				@unlink($upload_path . $picture_data[$i]['pic_thumb']);
			}
		}

		//Delete all sub categories
		$sql = 'DELETE FROM pro_cat WHERE '. $where_sql;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	//Get and delete picture of this cat
	$sql = 'SELECT pic_thumb FROM pro_cat WHERE cat_id='. $cid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result)){
		$picture_info = $db->sql_fetchrow($result);
		@unlink($upload_path . $picture_info['pic_thumb']);
	}
	//Delete this category
	$sql = 'DELETE FROM pro_cat WHERE cat_id='. $cid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	
	resync_cat();
}

function get_sub_cat_id($parent_id,&$sql){
	global $cat_data;

	$tmpcat = $cat_data;
	if (!isset($tmpcat['parent_id']) || !is_array($tmpcat['parent_id']) ) return false;

	reset($tmpcat);
	while (list($key, $pid) = each($tmpcat['parent_id'])){
		if ($pid == $parent_id){
			$sql .= ' OR cat_id='. $tmpcat["cat_id"][$key];
			get_sub_cats($tmpcat["cat_id"][$key], $sql);
		}
	}

	return true;
}

function show_cats(){
	global $db, $cat_data, $template, $sort_catdata;

	$template->assign_block_vars("havecatparent",array());

	if ( !isset($sort_catdata['cat_id']) || !is_array($sort_catdata['cat_id'])) return false;

	reset($sort_catdata['cat_id']);
	while (list($key, $id) = each($sort_catdata['cat_id']))
	{
		$template->assign_block_vars("havecatparent.catrow",array(
			'CAT_ID'		=> $id,
			'TITLE_PREFIX'	=> (CAT_LEVEL>1) ? $sort_catdata['title_prefix'][$key] : '',
			'CAT_TITLE'		=> $sort_catdata['cat_title'][$key],
//			'CAT_CSS'	=> ($sort_catdata['level'][$key] < CAT_LEVEL) ? 'enabled' : 'disabled',
		));
	}

	return false;
}

function get_all_cats(){
	global $db, $cat_data, $template, $sort_catdata;

	//Get all cats
	$sql = 'SELECT * FROM pro_cat ORDER BY cat_order ASC';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result))
	{
		while ($tmpcat_info = $db->sql_fetchrow($result))
		{
			$cat_data['cat_id'][] 		= $tmpcat_info['cat_id'];
			$cat_data['parent_id'][] 	= $tmpcat_info['cat_parent_id'];
			$cat_data['cat_title'][] 	= $tmpcat_info['cat_title'];
			$cat_data['cat_counter'][] 	= $tmpcat_info['cat_counter'];
		}
	}
	$db->sql_freeresult($result);
}

function get_sub_cats($parent_id, $level, $getall=0, $cid=0, $str="", $prefix="|-- "){
	global $cat_data, $sort_catdata;

	$tmpcat = $cat_data;
	if (!isset($tmpcat['parent_id']) || !is_array($tmpcat['parent_id']) ) return false;

	reset($tmpcat);
	while (list($key, $pid) = each($tmpcat['parent_id'])){
		if ( $cid == $tmpcat['cat_id'][$key] ) continue;

		if ($pid == $parent_id){
			$sort_catdata["cat_id"][] = $tmpcat["cat_id"][$key];
//			$sort_catdata["cat_title"][] = $str .$prefix. $tmpcat["cat_title"][$key];
			$sort_catdata["title_prefix"][] = $str .$prefix;
			$sort_catdata["cat_title"][] = $tmpcat["cat_title"][$key];

			$str2 = $str . "&nbsp; &nbsp; &nbsp;";
			$sort_catdata["cat_counter"][] = $tmpcat["cat_counter"][$key];
			$sort_catdata["level"][] = $level;

			if ( $getall || ($level < CAT_LEVEL - 1) ){
				get_sub_cats($tmpcat["cat_id"][$key], $level+1, $getall, $cid, $str2, $prefix);
			}
		}
	}

	return true;
}

function get_sub_cats_2($parent_id, $level, $getall=0, $cid=0, $str=""){
	global $cat_data, $sort_catdata;

	$tmpcat = $cat_data;
	if (!isset($tmpcat['parent_id']) || !is_array($tmpcat['parent_id']) ) return false;

	reset($tmpcat);
	while (list($key, $pid) = each($tmpcat['parent_id'])){
		if ( $cid == $tmpcat['cat_id'][$key] ) continue;
		
		if ($pid == $parent_id){
			$sort_catdata["cat_id"][] = $tmpcat["cat_id"][$key];
//			$sort_catdata["cat_title"][] = $str . $tmpcat["cat_title"][$key];
			$sort_catdata["title_prefix"][] = $str;
			$sort_catdata["cat_title"][] = $tmpcat["cat_title"][$key];

			$sort_catdata["cat_counter"][] = $tmpcat["cat_counter"][$key];
			$sort_catdata["level"][] = $level;

			if ( $getall || ($level < CAT_LEVEL - 1) ){
				$str2 = $str . $tmpcat["cat_title"][$key] . "/";
				get_sub_cats_2($tmpcat["cat_id"][$key], $level+1, $getall, $cid, $str2);
			}
		}
	}

	return true;
}

function bring_up_cat(){
	global $db, $template_edit_page;

	$cid = isset($_GET['cid']) ? intval($_GET['cid']) : '';

	$sql = 'SELECT cat_parent_id,cat_order FROM pro_cat WHERE cat_id='. $cid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if (!$db->sql_numrows($result))
	{
		die('Not exist this cat id: '.$cid);
		return false;
	}
	$cat_info		= $db->sql_fetchrow($result);
	$parent_id		= $cat_info['cat_parent_id'];
	$current_order	= $cat_info['cat_order'];
	$db->sql_freeresult($result);
	unset($cat_info);

	$sql = 'SELECT cat_id,cat_order FROM pro_cat WHERE cat_order<='. $current_order .' AND cat_id!='. $cid .' AND cat_parent_id='. $parent_id .' ORDER BY cat_order DESC';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result))
	{
		$cat_info 	= $db->sql_fetchrow($result);
		$up_id 		= $cat_info['cat_id'];
		$up_order 	= $cat_info['cat_order'];
		$db->sql_freeresult($result);
		unset($cat_info);

		$sql = 'UPDATE pro_cat SET cat_order='. $up_order .' WHERE cat_id='. $cid;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}

		$sql = 'UPDATE pro_cat SET cat_order='. $current_order .' WHERE cat_id='. $up_id;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	list_cats();
	return true;
}

function bring_down_cat(){
	global $db, $template_edit_page;

	$cid = isset($_GET['cid']) ? intval($_GET['cid']) : '';

	$sql = 'SELECT cat_parent_id,cat_order FROM pro_cat WHERE cat_id='. $cid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if (!$db->sql_numrows($result))
	{
		die('Not exist this cat id: '.$cid);
		return false;
	}
	$cat_info 		= $db->sql_fetchrow($result);
	$parent_id 		= $cat_info['cat_parent_id'];
	$current_order 	= $cat_info['cat_order'];
	$db->sql_freeresult($result);
	unset($cat_info);

	$sql = 'SELECT cat_id,cat_order FROM pro_cat WHERE cat_order>='. $current_order .' AND cat_id!='. $cid .' AND cat_parent_id='. $parent_id .' ORDER BY cat_order ASC';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result))
	{
		$cat_info 	= $db->sql_fetchrow($result);
		$down_id 	= $cat_info['cat_id'];
		$down_order = $cat_info['cat_order'];
		$db->sql_freeresult($result);
		unset($cat_info);

		$sql = 'UPDATE pro_cat SET cat_order='. $down_order .' WHERE cat_id='. $cid;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}

		$sql = 'UPDATE pro_cat SET cat_order='. $current_order .' WHERE cat_id='. $down_id;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	list_cats();
	return true;
}

function resync_cat(){
	global $db, $template_edit_page;

	$sql = 'UPDATE pro_cat SET cat_counter=0';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	$sql = 'SELECT cat_id,count(product_id) AS counter FROM pro GROUP BY cat_id';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$cat_count = $db->sql_numrows($result);
	$cat_data  = $db->sql_fetchrowset($result);

	for ($i=0;$i<$cat_count;$i++){
		$sql = 'UPDATE pro_cat SET cat_counter='. $cat_data[$i]['counter'] .' WHERE cat_id='. $cat_data[$i]['cat_id'];
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	list_cats();
}
?>