

<?php
define('IN_SITE', true);
include("common.php");
$base_url 				= 'user.php';
$template_body_page 	= "user_body.tpl";
$template_edit_page 	= "user_edit.tpl";
$template_perm_page 	= "user_perm.tpl";

$auth_level 	= check_any_auth($base_url);

//----------------------- Filter --------------------------
$filter			= isset($_POST["filter"]) ? htmlspecialchars($_POST["filter"]) : '';
$keyword		= isset($_POST["keyword"]) ? htmlspecialchars($_POST["keyword"]) : '';
if (empty($filter))
{
	$filter		= isset($_GET["filter"]) ? htmlspecialchars($_GET["filter"]) : '';
}
if (empty($keyword))
{
	$keyword 	= isset($_GET["keyword"]) ? htmlspecialchars(urldecode($_GET["keyword"])) : '';
}
//---------------------------------------------------------

$start		= isset($_GET["start"]) ? intval($_GET["start"]) : 0;
$mode		= isset($_GET["mode"]) ? htmlspecialchars($_GET["mode"]) : '';
switch ($mode)
{
	case "add":
		check_specify_auth($auth_level,'add');
		pre_add_user();
		break;
	case "addsm":
		check_specify_auth($auth_level,'add');
		do_add_user();
		break;
	case "edit":
		check_specify_auth($auth_level,'edit');
		pre_edit_user();
		break;
	case "editsm":
		check_specify_auth($auth_level,'edit');
		do_edit_user();
		break;
	case "del":
		check_specify_auth($auth_level,'delete');
		delete_user();
		break;
	case "active":
		check_specify_auth($auth_level,'active');
		active_users();
		break;
	case "setperm":
		check_specify_auth($auth_level,'edit');
		pre_set_perm();
		break;
	case "setpermsm":
		check_specify_auth($auth_level,'edit');
		do_set_perm();
		break;
	case "kill":
		kill_user();
		break;		
	default:
		list_users();
}

function list_users(){
	global $lang, $template, $db, $site_option, $base_url, $template_body_page, $function_name, $auth_level, $filter, $keyword, $start;

	$timezone		= $site_option['timezone'];
	$dateformat		= $site_option['date_format'];
	$itemperpage	= $site_option['items_per_page'];
	$expiretime		= $site_option['login_expiretime'];

	$template->set_filenames(array(
		"body"	=> $template_body_page
	));

	$where_sql = '';
	if ($filter === 'enabled'){
		$where_sql = ' WHERE user_active=1';
	}
	else if ($filter === 'disabled'){
		$where_sql .= ' WHERE user_active=0';
	}
	if (!empty($keyword)){
		$where_sql .= (!empty($where_sql)) ? ' AND' : ' WHERE';
		$where_sql .= " username LIKE('%". str_replace('*','%',$keyword) ."%')";
	}
	$sql = 'SELECT * FROM admin_users '. $where_sql .' ORDER BY username ASC LIMIT '. $start .','. $itemperpage;

	//Get users
	if ( !$result = $db->sql_query($sql) )
	{
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$user_count = $db->sql_numrows($result);
	$user_data = $db->sql_fetchrowset($result);

	//Generate Pagination
	$sql = 'SELECT count(*) AS total FROM admin_users ' . $where_sql;
	if (!$result = $db->sql_query($sql)) {
		message_die("Error getting total count.", __LINE__, __FILE__, $sql);
	}
	else {
		$total 			= $db->sql_fetchrow($result);
		$total_items 	= $total['total'];
		$pagination 	= pagination($base_url . "?keyword=$keyword&filter=$filter", $total_items, $itemperpage, $start, 'start', $lang['general_page'] . ': //<img src="images/prev.gif" border="0">//<img src="images/next.gif" border="0">')."&nbsp;";
	}

	$user_info = get_user_info();
	if ($user_info['user_level'] == SYSTEM_ADMIN)
	{
		$auth_add 		= 1;
		$auth_edit 		= 1;
		$auth_delete 	= 1;
		$auth_active 	= 1;
	}
	else
	{
		$auth_add 		= (check_specify_auth($auth_level,'add',0)) ? 1 : 0;
		$auth_edit 		= (check_specify_auth($auth_level,'edit',0)) ? 1 : 0;
		$auth_delete 	= (check_specify_auth($auth_level,'delete',0)) ? 1 : 0;
		$auth_active 	= (check_specify_auth($auth_level,'active',0)) ? 1 : 0;
	}

	$login_time = time() - $expiretime;
	for ($i=0;$i<$user_count;$i++){
		$template->assign_block_vars("userrow",array(
			'USER_ID'			=> $user_data[$i]["user_id"],
			'USERNAME'			=> $user_data[$i]["username"],
			'USERLEVEL'			=> ($user_data[$i]["user_level"] == SYSTEM_ADMIN) ? 'Administrator' : 'User',
			'USERACTIVE'		=> ($user_data[$i]["user_active"]) ? 'enabled' : 'disabled',
			'LASTLOGIN'			=> ($user_data[$i]["user_login_time"]) ? gmdate($dateformat, $user_data[$i]["user_login_time"] + $timezone*3600) : '&nbsp;',
			'USER_CHECKBOX'		=> ($user_info['user_id'] != $user_data[$i]['user_id']) ? '<input type="Checkbox" name="uid[]" value="'. $user_data[$i]["user_id"] .'" />' : '&nbsp;',
			'USER_STATUS'		=> (!empty($user_data[$i]["user_login_id"]) && ($user_data[$i]["user_login_time"] >= $login_time) ) ? (($user_info['user_id'] != $user_data[$i]['user_id']) ? '<a href="'. $base_url .'?mode=kill&uid='. $user_data[$i]['user_id'] .'" title="'. $lang['force_user_logout'] .'">'. $lang['user_online'] .'</a>' : $lang['user_online']) : '&nbsp;',
			'USER_IP'			=> (!empty($user_data[$i]["user_login_id"]) && ($user_data[$i]["user_login_time"] >= $login_time) ) ? $user_data[$i]['user_ip'] : '&nbsp;',
			'U_USER_EDIT'		=> ($auth_edit && ($user_info['user_id'] != $user_data[$i]['user_id'])) ? '<a  href="'. $base_url ."?mode=edit&uid=". $user_data[$i]["user_id"] .'&filter='.$filter.'&keyword='.$keyword.'&start='.$start.'"><img src=images/edit.gif width=16 height=16 border=0 alt="'. $lang['general_edit'] .'"></a>' : '&nbsp;',
			'U_USER_PERM'		=> ($auth_edit) ? (($user_data[$i]['user_level'] != SYSTEM_ADMIN) ? '<a  href="'. $base_url . "?mode=setperm&uid=" . $user_data[$i]["user_id"] .'&filter='.$filter.'&keyword='.$keyword.'&start='.$start.'"><img src=images/edit.gif width=16 height=16 border=0 alt="'. $lang['user_set_permission'] .'"></a>' : '&nbsp;') : '&nbsp;',
		));
	}

	$template->assign_vars(array(
		'U_NEW_USER'			=> ($auth_add) ? '<a href="'. $base_url . '?mode=add"><img src="images/new.gif" width="20" height="14" alt="'. $lang['general_new'] .'" border="0" align="absbottom">'. $lang['general_new'] .'</a>' : '&nbsp;',
		'S_LIST_ACTION'			=> $base_url . '?mode=active&filter='.$filter.'&keyword='.$keyword.'&start='.$start,
		'S_FILTER_ACTION'		=> $base_url,
		'FILTER_ENABLED'		=> ($filter === 'enabled') ? 'selected' : '',
		'FILTER_DISABLED'		=> ($filter === 'disabled') ? 'selected' : '',
		'SEARCH_KEYWORD'		=> $keyword,
		'NAVIGATOR'				=> $pagination,
		'U_USER_ACTIVE'			=> ($auth_active) ? '<a href="javascript:submit_list(\'enable\');"><img src="images/enabled.gif" width="20" height="14" alt="'. $lang['general_enable'] .'" border="0" align="absbottom">'. $lang['general_enable'] .'</a> &nbsp;-&nbsp; <a href="javascript:submit_list(\'disable\');"><img src="images/disabled.gif" width="20" height="14" alt="'. $lang['general_disable'] .'" border="0" align="absbottom">'. $lang['general_disable'] .'</a>' : '&nbsp;',
		'U_USER_DELETE'			=> ($auth_delete) ? '<a  href="javascript: delete_list(\''. $base_url.'?mode=del&filter='. $filter .'&keyword='.$keyword.'&start='.$start .'\');"><img src=images/del.gif width=16 height=16 border=0 alt="'. $lang['general_del'] .'"> '. $lang['general_del'] .'</a>' : '&nbsp;',
		'L_PAGE_NAVIGATION'		=> $lang['menu_user'] . $lang['general_arrow'] . $lang['menu_user_user'],
		'L_USERNAME'			=> $lang['general_username'],
		'L_LEVEL'				=> $lang['user_level'],
		'L_LAST_LOGIN'			=> $lang['user_last_login'],
		'L_STATUS'				=> $lang['user_status'],
		'L_IP'					=> $lang['general_ip'],
		'L_PERMISSION'			=> $lang['user_permission'],
		'L_EDIT'				=> $lang['general_edit'],
		'L_DEL'					=> $lang['general_del'],
		'L_ALL'					=> $lang['general_all'],
		'L_ENABLED'				=> $lang['general_enabled'],
		'L_DISABLED'			=> $lang['general_disabled'],
		'L_CHOOSE_USER'			=> $lang['error_user_not_choose'],
		'L_GO_SUBMIT'			=> $lang['button_go'],
	));	
	$template->pparse('body');
}

function pre_add_user($msg=""){
	global $lang, $template, $base_url, $template_edit_page;

	$template->set_filenames(array(
		"body"	=> $template_edit_page
	));
	$template->assign_vars(array(
		"L_ERR_MESSAGE"			=> $msg,
		'S_ACTION'				=> $base_url . '?mode=addsm',
		'SYS_ADMIN'				=> SYSTEM_ADMIN,
		'SYS_USER'				=> SYSTEM_USER,
		'L_PAGE_NAVIGATION'		=> $lang['menu_user'] . $lang['general_arrow'] . $lang['menu_user_user'] . $lang['general_arrow'] . $lang['general_new'],
		'L_PASSWORD'			=> $lang['general_password'],
		'L_CONFIRM_PASS'		=> $lang['general_confirm_password'],
		'L_USERNAME'			=> $lang['general_username'],
		'L_LEVEL'				=> $lang['user_level'],
		'L_ACTIVE'				=> $lang['general_active'],
		'L_ENABLED'				=> $lang['general_enabled'],
		'L_DISABLED'			=> $lang['general_disabled'],
		'L_PAGETO'				=> $lang['general_pageto'],
		'L_GOTO_LISTPAGE'		=> $lang['general_goto_listpage'],
		'L_CONTINUE_ADD'		=> $lang['general_continue_add'],
		'L_SUBMIT'				=> $lang['button_new'],
	));
	$template->assign_block_vars("addrow",array());
	$template->pparse('body');
}

function do_add_user(){
	global $lang, $template, $db;

	$username		= isset($_POST["username"]) ? htmlspecialchars($_POST["username"]) : '';
	$password		= isset($_POST["password"]) ? htmlspecialchars($_POST["password"]) : '';
	$confirmpass	= isset($_POST["password2"]) ? htmlspecialchars($_POST["password2"]) : '';
	$level			= isset($_POST["level"]) ? intval($_POST["level"]) : SYSTEM_USER;
	$active			= isset($_POST["active"]) ? intval($_POST["active"]) : 0;
	$pageto			= isset($_POST["pageto"]) ? htmlspecialchars($_POST["pageto"]) : '';

	if (empty($username)||empty($password)||empty($confirmpass)){
		$template->assign_vars(array(
			'PAGETO_VALUE'		=> $pageto
		));
		pre_add_user($lang['error_no_allfields']);
		return;	
	}
	//Check confirm password
	if ($confirmpass != $password)
	{
		$template->assign_vars(array(
			'PAGETO_VALUE'		=> $pageto
		));
		pre_add_user($lang['error_confirm_pass']);
		return;
	}

	//Check username exist ?
	$sql = "SELECT user_id FROM admin_users WHERE username='" . $username . "'";
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result))
	{
		$template->assign_vars(array(
			'PAGETO_VALUE'		=> $pageto
		));
		pre_add_user($lang['error_existed_username']);
		return;	
	}

	//Insert new user
	$sql = "INSERT INTO admin_users( username, user_password, user_level, user_login_id, user_login_time, user_ip, user_language, user_active)";
	$sql .= " VALUES('$username','" . md5($password) . "', $level, '', '', '', '', $active)";
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	if ($pageto == 'editpage'){
		$template->assign_vars(array(
			'PAGETO_VALUE'		=> $pageto,
		));
		pre_add_user($lang['success_add']);
	}
	else{
		list_users();
	}

	return;	
}

function pre_edit_user($msg=""){
	global $lang, $template, $db, $base_url, $template_edit_page, $filter, $keyword,$start;

	$uid = isset($_GET["uid"]) ? intval($_GET["uid"]) : 0;

	$sql = 'SELECT * FROM admin_users WHERE user_id=' . $uid;
	if ( !$result = $db->sql_query($sql) )
	{
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if (!$db->sql_numrows($result))
	{
		redirect($base_url);//User does not exist, redirect to user list page
		return;
	}

	$user_info = $db->sql_fetchrow($result);
	
	$template->set_filenames(array(
		'body'		=> $template_edit_page,
	));
	$template->assign_vars(array(
		'USERID_VALUE'			=> $uid,
		'L_ERR_MESSAGE'			=> $msg,
		'S_ACTION'				=> $base_url . '?mode=editsm&uid=' . $uid .'&filter='. $filter .'&keyword='. $keyword .'&start='. $start,
		'USERNAME_VALUE'		=> $user_info["username"],
		'USERLEVEL_VALUE'		=> $user_info["user_level"],
		'USERACTIVE_VALUE'		=> $user_info["user_active"],
		'SYS_ADMIN'				=> SYSTEM_ADMIN,
		'SYS_USER'				=> SYSTEM_USER,
		'L_PAGE_NAVIGATION'		=> $lang['menu_user'] . $lang['general_arrow'] . $lang['menu_user_user'] . $lang['general_arrow'] . $lang['general_edit'],
		'L_PASSWORD'			=> $lang['general_new_password'],
		'L_CONFIRM_PASS'		=> $lang['general_confirm_new_pass'],
		'L_PASS_OPTIONAL'		=> $lang['general_optional'],
		'L_USERNAME'			=> $lang['general_username'],
		'L_LEVEL'				=> $lang['user_level'],
		'L_ACTIVE'				=> $lang['general_active'],
		'L_ENABLED'				=> $lang['general_enabled'],
		'L_DISABLED'			=> $lang['general_disabled'],
		'L_SUBMIT'				=> $lang['button_edit'],
	));
	$template->pparse('body');
	return;
}

function do_edit_user(){
	global $db;

	$uid			= isset($_GET["uid"]) ? intval($_GET["uid"]) : 0;
	$username		= isset($_POST["username"]) ? htmlspecialchars($_POST["username"]) : '';
	$newpass		= isset($_POST["password"]) ? htmlspecialchars($_POST["password"]) : '';
	$confirmpass	= isset($_POST["password2"]) ? htmlspecialchars($_POST["password2"]) : '';
	$level			= isset($_POST["level"]) ? intval($_POST["level"]) : SYSTEM_USER;
	$active			= isset($_POST["active"]) ? intval($_POST["active"]) : 0;

	if (empty($username)){
		$msg = "Please enter all required fields below.";
		pre_edit_user($msg);
		return;	
	}

	//Check username exist ?
	$sql = "SELECT user_id FROM admin_users WHERE username='" . $username . "' AND user_id!=$uid";
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result))
	{	
		$msg = "This username has existed! Please choose another one.";
		pre_edit_user($msg);
		return;	
	}

	//Check to ensure that admin can not disable himself
	$user_info = get_user_info();
	if ($user_info['user_id'] == $uid){
		$active = 1;
	}

	$sql = "UPDATE admin_users SET username='" . $username . "'";
	if (!empty($newpass))
	{
		//Check confirm password
		if ($confirmpass != $newpass)
		{
			$msg = "Confirm Password is invalid!";
			pre_edit_user($msg);
			return;	
		}
		$sql .= ", user_password='" . md5($newpass) . "'";
	}
	$sql .= ", user_level=$level, user_active=$active WHERE user_id=$uid";

	//Update user
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	if ($level){//Delete user auth access because this is admin who have all permission
		$sql = 'DELETE FROM admin_auth_access WHERE user_id='. $uid;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	list_users();
	return;	
}

function delete_user(){
	global $db, $base_url;

	$uid = isset($_POST["uid"]) ? $_POST["uid"] : '';

	if (!empty($uid))
	{
		if (!is_array($uid))
		{
			$user_id[0] = $uid;
		}
		else
		{
			$user_id = $uid;
		}
		unset($uid);

		$where_sql = 'user_id=-1';
		while (list(,$id)=each($user_id))
		{
			$id = intval($id);
			if ($id){
				$where_sql .= ' OR user_id='. $id;
			}
		}

		$sql = 'DELETE FROM admin_users WHERE '. $where_sql;
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	list_users();
}

function active_users(){
	global $template, $db, $base_url;
	
	$flag = isset($_POST["factive"]) ? htmlspecialchars($_POST["factive"]) : 'disable';
	$uid  = isset($_POST["uid"]) ? $_POST["uid"] : '';

	if (!empty($uid))
	{
		if (!is_array($uid))
		{
			$user_id[0] = $uid;
		}
		else
		{
			$user_id = $uid;
		}
		unset($uid);

		$active = ($flag == "enable") ? 1 : 0;
		$sql = 'UPDATE admin_users SET user_active=' . $active . ' WHERE user_id=-1';
		while (list(,$id)=each($user_id))
		{
			$id = intval($id);
			if ($id){
				$sql .= ' OR user_id=' . $id;
			}
		}
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	list_users();
}

function pre_set_perm($msg=""){
	global $lang, $template, $db, $base_url, $template_perm_page, $filter, $keyword, $start;

	$uid = isset($_GET["uid"]) ? intval($_GET["uid"]) : 0;

	$template->set_filenames(array(
		'body'	=> $template_perm_page,
	));

	//Get user level
	$sql = 'SELECT username,user_level FROM admin_users WHERE user_id=' . $uid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if (!$db->sql_numrows($result)){
		redirect($base_url);
		return;
	}
	$user_info  = $db->sql_fetchrow($result);
	$user_level = $user_info['user_level'];
	$db->sql_freeresult($result);

	//Get all access permission of this user
	$sql = 'SELECT function_id,auth_level FROM admin_auth_access WHERE user_id=' . $uid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$auth_count = $db->sql_numrows($result);
	$auth_data  = $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	//Sort auth array
	$auth = array();
	for ($i=0;$i<$auth_count;$i++)
	{
		$auth[$auth_data[$i]["function_id"]] = $auth_data[$i]['auth_level'];
	}
	unset($auth_count);
	unset($auth_data);

	//Get function groups
	$sql = 'SELECT * FROM admin_function_groups ORDER BY group_order ASC';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$group_count 	= $db->sql_numrows($result);
	$group_data 	= $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	//Get functions
	$sql = 'SELECT * FROM admin_functions WHERE function_alluser=0 ORDER BY function_order ASC';
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$function_count = $db->sql_numrows($result);
	$function_data  = $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	//Remove groups in which there is not any function
	remove_empty_groups($group_count,$group_data,$function_count,$function_data);

	for ($i=0;$i<$group_count;$i++)
	{
		$template->assign_block_vars("group",array(
			'GROUP_NAME'	=> $lang[$group_data[$i]["group_name"]],
			'GROUP_COLOR'	=> $group_data[$i]["group_color"],
		));

		for ($j=0;$j<$function_count;$j++)
		{
			if ($group_data[$i]["group_id"] == $function_data[$j]["group_id"])
			{
				$func_id = $function_data[$j]["function_id"];
				$auth_id = isset($auth[$func_id]) ? $auth[$func_id] : 0;
				$template->assign_block_vars("group.func",array(
					'FUNC_NAME'		=> $lang[$function_data[$j]["function_name"]],
					'FUNC_COMBO'	=> make_access_cbox('func_auth['. $func_id .']',$auth_id),
				));		
			}
		
		}
	}

	$template->assign_vars(array(
		'S_ACTION'				=> $base_url . '?mode=setpermsm&uid='.$uid .'&filter='. $filter .'&keyword='. $keyword .'&start='. $start,
		'USERNAME'				=> $user_info['username'],
		'L_ERR_MESSAGE'			=> $msg,
		'L_PAGE_NAVIGATION'		=> $lang['menu_user'] . $lang['general_arrow'] . $lang['menu_user_user'] . $lang['general_arrow'] . $lang['user_set_permission'],
		'L_FUNC_NAME'			=> $lang['user_func_name'],
		'L_PERMISSION'			=> $lang['user_permission'],
		'L_SUBMIT'				=> $lang['button_update'],
	));
	$template->pparse('body');
}

function remove_empty_groups(&$group_count,&$group_data,$function_count,$function_data)
{
	$tmpgroup_count = 0;
	$tmpgroup_data = array();

	for ($i=0;$i<$group_count;$i++)
	{
		$flag = 0;
		for ($j=0;$j<$function_count;$j++)
		{
			if ($group_data[$i]['group_id'] == $function_data[$j]['group_id'])
			{
				$flag = 1;
				break;
			}
		}
		
		if ($flag)
		{
			$tmpgroup_count++;
			$tmpgroup_data[] = $group_data[$i];
		}
	}

	$group_count = $tmpgroup_count;
	$group_data  = $tmpgroup_data;
}

function make_access_cbox($combo_name,$selected_value=""){
	global $lang;

	$str = '<select name="'. $combo_name .'">
	<option value="'. ACCESS_NONE .'"'. (( $selected_value == ACCESS_NONE ) ? ' selected' : '') . '>'. $lang['general_none'] .'</option>	
	<option value="'. ACCESS_DIRECTOR .'"'. (( $selected_value == ACCESS_DIRECTOR ) ? ' selected' : '') . '>'. $lang['group_admin'] .'</option>
	<option value="'. ACCESS_MANAGER .'"'. (( $selected_value == ACCESS_MANAGER ) ? ' selected' : '') . '>'. $lang['group_mod'] .'</option>
	<option value="'. ACCESS_TYPIST .'"'. (( $selected_value == ACCESS_TYPIST ) ? ' selected' : '') . '>'. $lang['group_typist'] .'</option>
	<option value="'. ACCESS_CHECKER .'"'. (( $selected_value == ACCESS_CHECKER ) ? ' selected' : '') . '>'. $lang['group_checker'] .'</option>
	</select>';
	
	return $str;
}

function do_set_perm(){
	global $template, $db, $base_url;

	$uid = isset($_GET["uid"]) ? intval($_GET["uid"]) : 0;
	$auth = isset($_POST["func_auth"]) ? $_POST["func_auth"] : '';

	if (!$uid||empty($auth)||!is_array($auth))
	{
		redirect($base_url);
		return;
	}

	//Delete old auth
	$sql = 'DELETE FROM admin_auth_access WHERE user_id='. $uid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	while (list($func_id,$auth_id) = each($auth)){
		if ( intval($auth_id) <= 0 ) continue;

		$sql = 'INSERT INTO admin_auth_access(user_id,function_id,auth_level) VALUES('. $uid .','. intval($func_id) .','. intval($auth_id) .')';
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
		}
	}

	list_users();
	return;
}

function kill_user(){
	global $db;

	$uid = isset($_GET['uid']) ? intval($_GET['uid']) : 0;

	$sql = "UPDATE admin_users SET user_login_id ='' WHERE user_id=". $uid;
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}

	list_users();
}
?>