<?php
define('IN_SITE', true);
include("common.php");

$base_url 				= 'products.php';
$image_path 			= 'images/product/';
$image_cat_path 		= 'images/product_cat/';
$template_body_page 	= 'products_body.tpl';
$template_cat_page 		= 'products_list.tpl';
$template_view_page 	= 'products_view.tpl';

$cid 		= isset($_GET['cid']) ? intval($_GET['cid']) : 0;
$id			= isset($_GET['id']) ? intval($_GET['id']) : 0;
$start 		= isset($_GET['start']) ? intval($_GET['start']) : 0;

//Search -----------------
$skeyword	= isset($_POST['skeyword']) ? htmlspecialchars($_POST['skeyword']) : '';
$scat_id	= isset($_POST['scat_id']) ? intval($_POST['scat_id']) : 0;
if ( empty($skeyword) ){
	$skeyword	= isset($_GET['skeyword']) ? htmlspecialchars($_GET['skeyword']) : '';
}
if ( !$scat_id ){
	$scat_id	= isset($_GET['scat_id']) ? intval($_GET['scat_id']) : 0;
}

if ( $skeyword || $scat_id ){
	$template->assign_vars(array(
		'SKEYWORD'		=> $skeyword,
		'SCAT_ID'		=> $scat_id
	));

	search_products();
	die();
}
//------------------------


if ( $id ){
	view_product();
}
else if ( $cid ){
	show_cat_menu($cid);
	list_products();
}
else{
	show_cat_menu();
	list_cats();
}

function show_cat_menu($cid = 0){
	global $db, $base_url, $template;

	//Get all cats
	$sql = 'SELECT * FROM pro_cat ORDER BY cat_order ASC';
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$cat_count = $db->sql_numrows($result);
	$cat_data  = $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	//Get parent cat of current
	$parent_id = -1;
	for ($i=0; $i<$cat_count; $i++){
		if ($cid == $cat_data[$i]['cat_id']){
			$parent_id = $cat_data[$i]['cat_parent_id'];
		}
	}

	for ($i=0; $i<$cat_count; $i++){
		if ( !$cat_data[$i]['cat_parent_id'] ){
			$template->assign_block_vars('catparent', array(
				'TITLE'			=> $cat_data[$i]['cat_title'],
				'U_CAT_LINK'	=> $base_url . '?cid='. $cat_data[$i]['cat_id'],
				'CAT_IMG'		=> ( ($cid == $cat_data[$i]['cat_id']) || ($parent_id == $cat_data[$i]['cat_id']) ) ? '<img src="images/dot.gif">' : '',
			));

			if ( ($cid == $cat_data[$i]['cat_id']) || ($parent_id == $cat_data[$i]['cat_id']) ){
				for ($j=0; $j<$cat_count; $j++){
					if ( $cat_data[$j]['cat_parent_id'] == $cat_data[$i]['cat_id'] ){
						$template->assign_block_vars('catparent.catchild', array(
							'TITLE'			=> $cat_data[$j]['cat_title'],
							'U_CAT_LINK'	=> $base_url . '?cid='. $cat_data[$j]['cat_id'],
						));
					}
				}
			}
		}
	}
}

function list_cats(){
	global $db, $template, $template_body_page, $base_url, $image_cat_path;

	//Get top cats
	$sql	= "SELECT * FROM pro_cat WHERE cat_parent_id=0 ORDER BY cat_order ASC";
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$cat_count	= $db->sql_numrows($result);
	$cat_data	= $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	$i		= 0;
	$cols	= 4;
	while ( $i < $cat_count ){
		$template->assign_block_vars("catrow", array());
		for ($j=0; $j<$cols; $j++){
			if ( $i < $cat_count ){
				$template->assign_block_vars("catrow.catcol",array(
					'PIC_THUMB'		=> !empty($cat_data[$i]['pic_thumb']) ? '<img src="'. $image_cat_path . $cat_data[$i]['pic_thumb'] .'" ALT="'. $cat_data[$i]['cat_title'] .'" border="0" vspace=5 hspace=5>' : '',
					'TITLE'			=> $cat_data[$i]['cat_title'],
					'U_VIEW'		=> $base_url . '?cid='. $cat_data[$i]['cat_id'],
				));
			}
			else{
				$template->assign_block_vars("catrow.catcol",array());
			}
			$i++;
		}
	}

	$template->assign_vars(array(
		'TDCOLS'	=> $cols,
		'TDWIDTH'	=> round(100/$cols) .'%'
	));

	$template->set_filenames(array(
		'body'	=> $template_body_page,
	));
	$template->pparse('body');
}

function list_products(){
	global $db, $template, $template_cat_page, $cid, $base_url, $base_order_url, $image_path, $start, $site_option;

	$itemperpage	= 10;
	$currency		= $site_option['product_currency'];

	//Get cat info -----------------
	$sql	= 'SELECT * FROM pro_cat WHERE cat_id='. $cid;
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", __LINE__, __FILE__, $sql);
	}
	if ( !$db->sql_numrows($result) ){
		list_cats();
		return false;
	}
	$cat_info	= $db->sql_fetchrow($result);
	//------------------------------

	//Get cat title -----------------
	$cat_title = '<a class="bTitle" href="'. $base_url .'?cid='. $cat_info['cat_id'] .'">'. $cat_info['cat_title'] .'</a>';
	if ( $cat_info['cat_parent_id'] ){
		//get cat parent title
		$sql	= 'SELECT * FROM pro_cat WHERE cat_id='. $cat_info['cat_parent_id'];
		if ( !$result = $db->sql_query($sql) ){
			message_die("Couldn't access to database!!!", __LINE__, __FILE__, $sql);
		}
		if ( !$db->sql_numrows($result) ){
			list_cats();
			return false;
		}
		$parent_info	= $db->sql_fetchrow($result);
		$cat_title		= '<a class="bTitle" href="'. $base_url .'?cid='. $parent_info['cat_id'] .'">'. $parent_info['cat_title'] ."</a>/". $cat_title;
	}
	//-------------------------------

	//Get children cats -------------
	$sql	= "SELECT cat_id FROM pro_cat WHERE cat_parent_id=$cid ORDER BY cat_order ASC";
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$cat_count	= $db->sql_numrows($result);
	$cat_data	= $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	$where_sql	= "WHERE enabled=1 AND (cat_id=$cid";
	for ($i=0; $i<$cat_count; $i++){
		$where_sql	.= " OR cat_id=". $cat_data[$i]['cat_id'];
	}
	$where_sql	.= ")";
	//-------------------------------

	//Get products
	$sql = "SELECT * FROM pro $where_sql ORDER BY code ASC LIMIT $start,$itemperpage";
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$product_count	= $db->sql_numrows($result);
	$product_data	= $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	//Generate Pagination
	$sql = 'SELECT count(*) AS total FROM pro '. $where_sql;
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", __LINE__, __FILE__, $sql);
	}
	else{
		$total		= $db->sql_fetchrow($result);
		$pagination	= pagination($base_url . "?cid=$cid", $total['total'], $itemperpage, $start, 'start', 'Trang: //<img src="images/prev.gif" border="0">//<img src="images/next.gif" border="0">');
	}

	//List products in multi-cols --------
	$cols	= 1;
	$i		= 0;
	while ( $i < $product_count ){
		$template->assign_block_vars("productrow", array());
		for ($j=0; $j<$cols; $j++){
			if ($i < $product_count){
				$template->assign_block_vars("productrow.productcol", array(
					'PIC_THUMB'		=> !empty($product_data[$i]['pic_thumb']) ? '<img src="'. $image_path . $product_data[$i]['pic_thumb'] .'" ALT="'. $product_data[$i]['title'] .'" border="0">' : '',
					'CODE'			=> !empty($product_data[$i]['code']) ?  $product_data[$i]['code'] : '',
//					'CODE'			=> $product_data[$i]['code'],
					'TITLE'			=> '  ví dụ: '.$product_data[$i]['title'],
					'DETAIL'		=> '  '.$product_data[$i]['detail'],
					'PRICE'			=> $product_data[$i]['price'] ? number_format($product_data[$i]['price'], DECIMALS, DEC_POINT, THOUSANDS_SEP) .' '. $currency : 'Liên hệ',
					'U_VIEW'		=> $base_url .'?id='. $product_data[$i]['product_id'],
					'U_ORDER'		=> $base_order_url . '?id='. $product_data[$i]['product_id'],
					'VIEW_MORE'		=> '(chi tiết v&#7873; sản phẩm line 219)'
				));
			}
			else{
				$template->assign_block_vars("productrow.productcol", array());
			}
			$i++;
		}
	}
	$template->assign_vars(array(
		'TDCOLS'	=> $cols,
		'TDWIDTH'	=> round(100/$cols) .'%'
	));
	//------------------------------------

	$template->assign_vars(array(
		'CAT_TITLE'			=> $cat_title,
		'NAVIGATOR'			=> $pagination,
	));

	$template->set_filenames(array(
		'body' => $template_cat_page
	));
	$template->pparse('body');
	return true;
}

function view_product(){
	global $db, $template, $base_url, $base_order_url, $template_view_page, $image_path, $id, $site_option;

	$currency	= $site_option['product_currency'];

	//Get products info
	$sql = 'SELECT * FROM pro WHERE enabled=1 AND product_id='. $id;
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	if ( !$db->sql_numrows($result) ){
		list_cats();
		return false;
	}
	$product_info	= $db->sql_fetchrow($result);

	//get cat title ---------------------
	$sql = 'SELECT cat_id, cat_parent_id, cat_title FROM pro_cat WHERE cat_id='. $product_info['cat_id'];
	if ( !$result = $db->sql_query($sql) ) {
		message_die("Couldn't access to database!!!", __LINE__, __FILE__, $sql);
	}
	if ( !$db->sql_numrows($result) ){
		list_cats();
		return false;
	}
	$cat_info	= $db->sql_fetchrow($result);
	$cat_title	= '<a class="bTitle" href="'. $base_url .'?cid='. $cat_info['cat_id'] .'">'. $cat_info['cat_title'] .'</a>';

	if ( $cat_info['cat_parent_id'] ){
		$sql = 'SELECT cat_id, cat_title FROM pro_cat WHERE cat_id='. $cat_info['cat_parent_id'];
		if ( !$result = $db->sql_query($sql) ) {
			message_die("Couldn't access to database!!!", __LINE__, __FILE__, $sql);
		}
		if ( !$db->sql_numrows($result) ){
			list_cats();
			return false;
		}
		$parent_info	= $db->sql_fetchrow($result);
		$cat_title		= '<a class="bTitle" href="'. $base_url .'?cid='. $parent_info['cat_id'] .'">'. $parent_info['cat_title'] ."</a>/". $cat_title;
	}
	//-----------------------------------

	show_cat_menu($product_info['cat_id']);

	$template->assign_vars(array(
		'CAT_TITLE'			=> $cat_title,
		'PIC_FULL'			=> !empty($product_info['pic_full']) ? '<img src="'. $image_path . $product_info['pic_full'] .'" ALT="'. $product_info['title'] .'" border="0">' : '',
		'TITLE'				=> $product_info['title'],
		'DETAIL'			=> restore_htmltags(nl2br($product_info['detail'])),
		'CODE'				=> $product_info['code'],
		'COLOR'				=> $product_info['color'],
		'DIMENSION'			=> $product_info['dimension'],						
		'PRICE'				=> ($product_info['price']) ? number_format($product_info['price'], DECIMALS, DEC_POINT, THOUSANDS_SEP) .' '. $currency : 'Liên hệ',
		'U_PRODUCT_ORDER'	=> $base_order_url . '?id='. $product_info['product_id'],
		'CURRENCY'			=> $currency,
		'U_CART_VIEW'		=> $base_order_url,
	));

	$template->set_filenames(array(
		'body' => $template_view_page
	));
	$template->pparse('body');
}


function search_products(){
	global $db, $template, $template_cat_page, $base_url, $base_order_url, $image_path, $start, $site_option, $scat_id, $skeyword;

	$itemperpage	= 6;
	$currency		= $site_option['product_currency'];

	$where_sql		= "WHERE enabled=1";
	if ( !empty($skeyword) ){
		$keyword	= str_replace('*', '%', $skeyword);
//		$where_sql	.= " AND (title LIKE '%". $keyword ."%' OR detail LIKE '%". $keyword ."%' OR code LIKE '%". $keyword ."%' OR dimension LIKE '%". $keyword ."%' OR color LIKE '%". $keyword ."%')";
		$where_sql	.= " AND (detail LIKE '%". $keyword ."%')";
	}
	if ( $scat_id ){
		$where_sql	.= " AND cat_id=$scat_id";
	}

	//Get products
	$sql = "SELECT * FROM pro $where_sql ORDER BY code ASC LIMIT $start,$itemperpage";
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", "", __LINE__, __FILE__, $sql);
	}
	$product_count	= $db->sql_numrows($result);
	$product_data	= $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	//Generate Pagination
	$sql = 'SELECT count(*) AS total FROM pro '. $where_sql;
	if ( !$result = $db->sql_query($sql) ){
		message_die("Couldn't access to database!!!", __LINE__, __FILE__, $sql);
	}
	else{
		$total		= $db->sql_fetchrow($result);
		$pagination	= pagination($base_url . "?skeyword=$skeyword&scat_id=$scat_id", $total['total'], $itemperpage, $start, 'start', 'Trang: //<img src="images/prev.gif" border="0">//<img src="images/next.gif" border="0">');
	}

	//List products in multi-cols --------
	$cols	= 1;
	$i		= 0;
	while ( $i < $product_count ){
		$template->assign_block_vars("productrow", array());
		for ($j=0; $j<$cols; $j++){
			if ($i < $product_count){
				$template->assign_block_vars("productrow.productcol", array(
					'PIC_THUMB'		=> !empty($product_data[$i]['pic_thumb']) ? '<img src="'. $image_path . $product_data[$i]['pic_thumb'] .'" ALT="'. $product_data[$i]['title'] .'" border="0">' : '',
					'CODE'			=> !empty($product_data[$i]['code']) ? $product_data[$i]['code'] : '',
					'TITLE'			=> '  ví dụ: '.$product_data[$i]['title'],
					'DETAIL'		=> '  '.$product_data[$i]['detail'],
					'PRICE'			=> $product_data[$i]['price'] ? number_format($product_data[$i]['price'], DECIMALS, DEC_POINT, THOUSANDS_SEP) .' '. $currency : 'Liên hệ',
					'U_VIEW'		=> $base_url .'?id='. $product_data[$i]['product_id'],
					'U_ORDER'		=> $base_order_url . '?id='. $product_data[$i]['product_id'],
					'VIEW_MORE'		=> '(Xem nghĩa 359)'
				));
			}
			else{
				$template->assign_block_vars("productrow.productcol", array());
			}
			$i++;
		}
	}
	$template->assign_vars(array(
		'TDCOLS'	=> $cols,
		'TDWIDTH'	=> round(100/$cols) .'%'
	));
	//------------------------------------

	$template->assign_vars(array(
		'CAT_TITLE'			=> '<font class=bTitle>Kết quả tìm kiếm <br></font>',
		'NAVIGATOR'			=> $pagination,
	));

	$template->set_filenames(array(
		'body' => $template_cat_page
	));
	$template->pparse('body');
	return true;
}

?>